;****I* idl/idl.asctab
; NAME
; asctab
; 
; PURPOSE
; To convert binary data to text using the ASCII alternate from the
; early 1980s (used by the Japanese in early GMS files).
; 
; This byte to text mapping was an alternate to ASCII, but less widely
; used.
; 
; USAGE
; See routines that call this procedure.
; 
; INPUT
; 
; OUTPUT
; Text/string based on the byte input.
; 
; RESULT
; EXAMPLE
; USES
; USED BY
; * b3_channel_order.pro
; * b1read_jma_gms.pro
; 
; NOTES
; TODO
; BUGS
; AUTHOR
; Ken Knapp, NOAA/NCDC/RSAD
; 
; CREATION DATE
; Unknown
; 
; HISTORY
; Jun2010 - Added header
; 
; SOURCE

function asctab,byte
atab = [ ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',$
           ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',$
           ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',$
           ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',$
           ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',$
           ' ',' ',' ',' ',' ','.','<','(','+','|','&',' ',' ',' ',$
           ' ',' ',' ',' ',' ',' ','!','$','*',')',';','^','-','/',$
           ' ',' ',' ',' ',' ',' ',' ',' ',' ',',','%','_','>','?',$
           ' ',' ',' ',' ',' ',' ',' ',' ',' ','`',':','#','@','\',$
           '=','"',' ','a','b','c','d','e','f','g','h','i',' ',' ',$
           ' ',' ',' ',' ',' ','j','k','l','m','n','o','p','q','r',$
           ' ',' ',' ',' ',' ',' ',' ','~','s','t','u','v','w','x',$
           'y','z',' ',' ',' ','[',' ',' ',' ',' ',' ',' ',' ',' ',$
           ' ',' ',' ',' ',' ',' ',' ',']',' ',' ','{','A','B','C',$
           'D','E','F','G','H','I',' ',' ',' ',' ',' ',' ','}','J',$
           'K','L','M','N','O','P','Q','R',' ',' ',' ',' ',' ',' ',$
           '\\',' ','S','T','U','V','W','X','Y','Z',' ',' ',' ',' ',$
           ' ',' ','0','1','2','3','4','5','6','7','8','9',' ',' ',$
           ' ',' ',' ',' ']

return,atab(byte)
end

;***
