function choosevar,input
if (max(input) eq min(input)) then begin
    return,max(input)
endif else begin
    s = sort(input)
    u = uniq(input(s))
    n = n_elements(u)
    nn = intarr(n)
    nn(0) = u(0)+1
    ind = indgen(n-1)+1
    nn(ind) = u(ind)-u(ind-1)
    mx = max(nn,maxloc)
    return,input(s(u(maxloc)))
endelse
end

function comm_2_nav,comm

s=size(comm)
ny = s(2)

bn = reform(comm(99,*))
mfi= reform(comm(100,*))

word=swap_endian(long(comm(101:124,*),0,6,ny))

bestnav=lonarr(120)
j=0
for ibn=1,10 do begin
    for imfi=1,2 do begin
        l=where(bn eq ibn and mfi eq imfi,nl)
        if (nl gt 0) then begin
            for i=0,5 do begin
                bestnav(j++) = choosevar(word(i,l))
            endfor
        endif else begin
            bestnav(j++) = -99999
        endelse
    endfor
endfor

return,bestnav
end

;****I* idl/idl.b1read_noa_goe
; NAME
; b1read_noa_goe
; 
; PURPOSE
; Read B1 files created by NOAA/NCDC. The files are in McIDAS format,
; and thus use the idl.mcidas_read algorithm.
; 
; USAGE
; This routine should not be used except for testing. The user should
; read B1 files using b1read.pro instead.
; 
; USES
; * mcidas_read.pro
; * bittest.pro
; * ftime.pro
; * itime.pro
; * stripname.pro
; * yymmdd_2_yyjjj.pro
; * geo_struct.pro
; * bcd_time.pro
; * navcheck.pro
; * b1u_ij2ll.pro
; * b1u_ll2ij.pro
; 
; USED BY
; * b1read.pro
; 
; NOTES
; TODO
; BUGS
; AUTHOR
; Ken Knapp, NOAA/NCDC/RSAD
; CREATION DATE
; Tue Jun 26 09:51:47 EDT 2007
; HISTORY
; SOURCE

pro b1read_noa_goe,file=file, $
                   images=images, $
                   b1u=b1u, $
                   fhdr=fhdr, $
                   compress=compress, $
                   debug=debug, $
                   noaacal=noaacal
fhdr = -9999
b1ver = '$Id: b1read_noa_goe.pro 22772 2010-09-16 12:28:08Z kknapp $'

f=strsplit(file,'.',/extr)
spc = f(8)
year= f(4)
sat = f(3)
mon = f(5)
day = f(6)
g = strsplit(sat,'-',/extract)

mcidas_read,file=file,area=area,nav=nav,image=image,linhdr=lin
@geo_struct.pro
s=size(image)
if (area.num_chan eq 1 and s(0) eq 2) then image=reform(image,1,s(1),s(2))




if (fix(g(1)) lt 8) then begin
;==================================
; READER FOR 1992-1994 GAP
;==================================

    ;get navigation information from the linhdr

    ;p = comm_2_nav(lin(4:131,*))
    p = comm_2_nav(lin.doc)

    ;assign navigation parameters
    date1 = p(0)
    time1 = p(1)
    x1 = p(6)/2.d^13
    y1 = p(7)/2.d^13
    z1 = p(8)/2.d^13
    vx1 = p(09)/2.d^13
    vy1 = p(10)/2.d^13
    vz1 = p(11)/2.d^13

    sper = p(12)
    spra1= p(13)/2.d^21
    spdc1= p(14)/2.d^21
    zeta = p(15)/2.d^21
    rho =  p(16)/2.d^21
    eta =  p(17)/2.d^21
    gamma= p(18)/2.d^21
    names= p(19)
    id =   p(20)
    sra1 = p(21)/2.d^21
    sdc1 = p(22)/2.d^21
    gra1 = p(23)/2.d^21
    
    est  = p(24)
    eet  = p(25)
    fper = p(26)
    tc   = p(27)
    ce   = p(28:31)
    cr   = p(31:35)
    
    cb   = p(36:45)/273.d/2.d^11
    pnl  = p(46)
    rnl =  p(47)

    cx   = p(48:58)/2.d^13
    cy   = p(60:70)/2.d^13
    cz   = p(72:82)/2.d^13
    epy  = p(83)
    
    eph  = p(84)
    sma  = p(85)/100.d0
    ecc  = p(86)/1000000.d0
    inc  = p(87)/1000.d0
    ma   = p(88)/1000.d0
    ap   = p(89)/1000.d0
    ran  = p(90)/1000.d0
    sbscan=p(91)/100.d0
    sbsamp=p(92)/100.d0
    sblat= p(93)/100.d0
    sblong=p(94)/100.d0
    yaw  = p(95)/100.d0
    
    sbscanb=p(96)
    sbsamb =p(97)
    sblatb =p(98)
    sblongb=p(99)
    yawb   =p(100)
    x2   = p(102)/2.d^13
    y2   = p(103)/2.d^13
    z2   = p(104)/2.d^13
    vx2  = p(105)/2.d^13
    vy2  = p(106)/2.d^13
    vz2  = p(107)/2.d^13

    spra2 = p(109)/2.d^21
    spdc2 = p(110)/2.d^21
    deltal= p(111)/2.d^21
    deltas= p(112)/2.d^21
    sra2  = p(117)/2.d^21
    sdc2  = p(118)/2.d^21
    gra2  = p(119)/2.d^21

    ;check out the navigation coefficients
    navcheck,[date1,time1], $
             [x1,y1,z1],[vx1,vy1,vz1], $
             [x2,y2,z2],[vx2,vy2,vz2], $
             cx,cy,cz, $
             [epy,eph],[sma,ecc,inc,ran,ap,ma],result, $
             kepout=kepler,kepdate=kepdate
    datechange=1
    navok = 0
    if (result(0) eq 0) then begin
        ;convert pos1/vel1 --> kepler
        ;cart2kep,[x1,y1,z1],[vx1,vy1,vz1],kepler
        ;edate = date1
        ;etime = itime(time1/100./3600.)
        caldat,kepdate,mon,dom,year,hh,mm,ss
        edate = (year mod 100) * 1000l + $
                (yymmdd_2_yyjjj((year mod 100)*10000l + mon * 100l + dom) mod 1000)
        datechange=0
        etime = hh*10000l + mm * 100l  + floor(ss)
        msec = floor((ss mod 1.) * 1000.)
        semima = kepler(0)
        incl =   kepler(2)
        eccen =  kepler(1)
        meana =  kepler(5)
        rasc =   kepler(3)
        perigee =kepler(4)
        navok = 1
    endif else if (result(0) eq 1) then begin
        ;convert pos2/vel2 --> kepler
        ;cart2kep,[x2,y2,z2],[vx2,vy2,vz2],kepler
        ;edate = date1
        ;etime = itime(time1/100./3600.)
        ;add 13 hours to the date & time
        ;convert date/time to julian date
        ;    year=(date1 / 1000) + 1900
        ;    doy = date1 mod 1000
        ;    jul = julday(1,doy,year,0,0,etime/100.) + 13.0d0 / 24.0d0
        ;    caldat,jul,mon,dom,year,hh,mm,ss
        ;    edate = (year mod 100) * 1000l + $
        ;            (yymmdd_2_yyjjj((year mod 100)*10000l + mon * 100l + dom) mod 1000)
        ;    etime = hh*10000l + mm * 100l  + floor(ss)
        ;    msec = floor((ss mod 1.) * 1000.)
        caldat,kepdate,mon,dom,year,hh,mm,ss
        edate = (year mod 100) * 1000l + $
                (yymmdd_2_yyjjj((year mod 100)*10000l + mon * 100l + dom) mod 1000)
        datechange=0
        etime = hh*10000l + mm * 100l  + floor(ss)
        msec = floor((ss mod 1.) * 1000.)
        semima = kepler(0)
        incl =   kepler(2)
        eccen =  kepler(1)
        meana =  kepler(5)
        rasc =   kepler(3)
        perigee =kepler(4)
            ;since the epoch time is changed, we need
            ;to adjust SPRA1/2 and SPDC1/2
        spra3 = spra2 + (spra2-spra1)
        spdc3 = spdc2 + (spdc2-spdc1)
        spra1 = spra2 & spra2 = spra3
        spdc1 = spdc2 & spdc2 = spdc3
        navok = 1
    endif else if (result(0) eq 2) then begin
        ;use kepler elements
        edate =  epy
        etime =  eph
        msec =   0.
        semima = sma
        incl =   inc
        eccen =  ecc
        meana =  ma
        rasc =   ran
        perigee= ap
        navok = 1
    endif else begin
        ;huh???
        print,'Uh Oh, couldn''t figure out the navigation'
        print,'P',p
        print,'RESULT',result
        doc=lin.doc
        image=fix(image)
        image(0) = -1
        ;return
;        for i=0,128,10 do begin
;            window,xs=1000,ys=1100
;            !p.multi=[0,3,4]
;            for j=i,i+11 do begin
;                plot,doc(j,*),chars=2,title=strtrim(j,2),psym=3
;            endfor
;            stop
;        endfor
;        stop
;        return
    endelse 

    ;Set up the Kepler navigation header
    nx = area.num_elem
    ;ny = area.num_line
    ;the following works better, especially when the file header
    ;is wrong
    s=size(image)
    ny = s(3)
    nchan = area.num_chan
    ;semima = nav.semima/100.
    ;incl =   nav.orbinc / 1000.
    ;eccen =  nav.eccen / 1.e6
    ;meana =  nav.meana / 1000.
    ;rasc =   nav.asnode /1000.
    ;perigee= nav.perigee/1000.
    ;edate=   yymmdd_2_yyjjj(nav.etimy)
    ;etime=   nav.etimh
    ;msec =   0.0
    roll =   ftime(nav.roll)
    pitch =  ftime(nav.pitch)
    yaw =    ftime(nav.yaw)
    ;spra & spdc are currently unknown
    ;spra1 = 0.0d0
    ;spra2 = 0.0d0
    ;spdc1 = 0.0d0
    ;spdc2 = 0.0d0
    sline = area.north_bound
    spix =  area.west_vis_elem
    cen_lin = 7284 ;totscl*4 = 1821 * 4
    cen_pix = 7648 ;totsmp =* 2 = 3822*2
    linres = area.line_res
    pixres = area.elem_res
    linang = 1.d0/728.586d0
    pixang = 18.375d0/15288.d0 ; 2. * 9.1875 / 3822 / 4
    spper = 1.e-6 * nav.spinp
    frdate = area.img_date
    frtime = ftime(area.img_time)*3600.
    D = 13.d0*3600d0

    ;Assign variables to structures
    if (navok) then begin
        orbit.ep_date = edate
        if (datechange) then orbit.ep_date = yymmdd_2_yyjjj(edate)
        orbit.ep_time = etime
        orbit.ep_msec = msec
        orbit.semima = semima
        orbit.incl = incl
        orbit.eccen = eccen
        orbit.meana = meana
        orbit.rgtasc = rasc
        orbit.perigee = perigee
        orbit.sper = spper
        ORBstr = orbit
    endif
    imginfo.frdate = (frdate)
    imginfo.frtime = frtime
    imginfo.cen_lin = cen_lin
    imginfo.cen_pix = cen_pix
    imginfo.linres = linres
    imginfo.pixres = pixres
    imginfo.nlin = ny
    imginfo.npix = nx
    imginfo.sline = sline
    imginfo.spix = spix
    imginfo.linang = linang
    imginfo.pixang = pixang
    IMGstr = imginfo
    att.roll = roll
    att.pitch = pitch
    att.yaw = yaw
    att.rma = 0.d0
    att.pma = 0.d0
    ATTstr = att
    imginfo.frdate = frdate
    imginfo.frtime = frtime
    imginfo.cen_lin = cen_lin
    imginfo.cen_pix = cen_pix
    imginfo.linres = linres
    imginfo.pixres = pixres
    imginfo.nlin = ny
    imginfo.npix = nx
    imginfo.sline = sline
    imginfo.spix = spix
    imginfo.linang = linang
    imginfo.pixang = pixang
    chninfo.nchan = area.num_chan

    if (area.num_line lt 11) then begin
        print,'Why here?'
        images=-1
        return
    endif

    for i=0,area.num_chan-1 do begin
        ;iband = lin(132+i,20)
        iband = lin(10).level(i)
        if (iband eq 1) then begin ;visible
            chninfo.ch_name(i) = 'VSCHN'
            chninfo.ch_info(i) = '0.52-0.73 um'
        endif else if (iband eq 8) then begin
            chninfo.ch_name(i) = 'IRWIN'
            chninfo.ch_info(i) = '10.3-12.1 um'
        endif else if (iband eq 7) then begin
            chninfo.ch_name(i) = 'IRSPL'
            chninfo.ch_info(i) = '12.5-12.8 um'
        endif else if (iband eq 10) then begin
            chninfo.ch_name(i) = 'IRWVP'
            chninfo.ch_info(i) = '6.40-7.08 um'
        endif else  begin
            print,'Unknown channel'
            print,'IBAND:',iband
            chninfo.ch_name(i) = 'Unknown'
            chninfo.ch_info(i) = 'Invalid'
        endelse
    endfor
    CHNstr = chninfo
    sattim.d = d
    sattim.gt1 = 0.
    sattim.gt2 = 0.
    sattim.gra1 = gra1
    sattim.gra2 = gra2
    sattim.spra1 = spra1
    sattim.spra2 = spra2
    sattim.spdc1 = spdc1
    sattim.spdc2 = spdc2
    sattim.cheb_x = cx
    sattim.cheb_y = cy
    sattim.cheb_z = cz
    sattim.cheb_a = -999.d0
    sattim.cheb_b = -999.d0
    sattim.cheb_c = -999.d0
    TIMstr = sattim

    if (navok) then begin

        inlat = 0.0d0
        inlon = -100.d0
        b1u_ll2ij,inlat,inlon,i,j, $
                  glat=glat,glon=glon,grad=grad, $
                  b1TIMstr=TIMstr,b1ORBstr=ORBstr, $
                  b1ATTstr=ATTstr,b1IMGstr=IMGstr
        if (glon lt (-180)) then glon = glon + 360.d0
        if (glon gt 180)    then glon = glon - 360.d0
        
        b1u_ij2ll,1,imgstr.sline,lat,lon, $
                  glat=glat1c,glon=glon1c,grad=grad1c, $
                  b1TIMstr=TIMstr,b1ORBstr=ORBstr,b1ATTstr=ATTstr,b1IMGstr=IMGstr
        
        b1u_ij2ll,1,imgstr.sline+IMGstr.nlin*IMGstr.linres,lat,lon, $
                  glat=glat2c,glon=glon2c,grad=grad2c, $
                  b1TIMstr=TIMstr,b1ORBstr=ORBstr,b1ATTstr=ATTstr,b1IMGstr=IMGstr

    endif



    ;calibration information for SMS & GOES 1-7
    print,nchan

    count=indgen(256)
    noaacal = fltarR(2,nchan,256)
    irloc = where(strtrim(chninfo.ch_name,2) eq 'IRWIN')
    if (irloc(0) ge 0 and irloc(0) lt nchan) then begin
        noaacal(1,irloc(0),0:176) = 330.-count(0:176)/2.
        noaacal(1,irloc(0),177:255)=418-count(177:255)
        wvl=11.e-4
        c = 1.44
        noaacal(0,irloc(0),*) = (1.195e-5)*(wvl^(-3))*(exp(c/wvl/noaacal(1,irloc(0),*))-1.)^(-1)
    endif
    irloc = where(strtrim(chninfo.ch_name,2) eq 'VSCHN')
    if (irloc(0) ge 0 and irloc(0) lt nchan) then begin
        noaacal(*,irloc(0),*) = -999.
    endif

    if keyword_set(debug) then stop

;---------------------------------------------------
;\_/\_/\_/\_/\_/\_/\_/\_/\_/\_/\_/\_/\_/\_/\_/\_/\_/
;
; BEGIN B1U array definitions
;
    MISSING = -9999l
    REVinf = strarr(6)
    IMGinf = lonarr(24)
    SATinf = strarr(34)
    NAVinf = lonarr(200)
    PREinf = intarr(nchan,20,IMGstr.nlin)
;validation code
;print,swap_endian(long(linhdr(0:3,0),0,1))
;print,area.val_code
    ;REVISION INFORMATION
    REVinf(*) = 'Missing'
    REVinf(0) = stripname(file)
    REVinf(3) = b1ver

    IMGinf(*) = MISSING
    IMGinf(0) = IMGstr.frdate
    IMGinf(1) = itime(IMGstr.frtime/3600.)
    IMGinf(2) = MISSING         ;areadir.sss
    IMGinf(3) = IMGstr.nlin     ;areadir.nline
    IMGinf(4) = IMGstr.npix     ;areadir.nelem
    IMGinf(5) = nchan
    IMGinf(6) = 1               ;areadir.bytes
    IMGinf(7) = 1               ;N-S orientation
    IMGinf(8) = 0               ;E-W orientation
    IMGinf(9) = -999            ;Vis averaging: -999=MISSING
    IMGinf(10) = MISSING
    IMGinf(11) = fix(area.val_code)
    IMGinf(12) = 0              ;no image byte offset
    IMGinf(13) = 0              ;neither Imager or Sounder

    i=0
    SATinf(*) = 'Missing'
    f = strsplit(file,'.',/extr)
    ipo = (strsplit(f(3),'-',/extr))[1]
    SATinf(i++) = 'GOES-'+ipo
    SATinf(i++) = 'VISSR'
    for j=0,nchan-1 do begin
        SATinf(i++) = chninfo.ch_name(j)
    endfor
    for j=0,nchan-1 do begin
        SATinf(i++) = chninfo.ch_info(j)
    endfor

; Navigation information
; Keplarian information
    i=0
    NAVinf(*) = MISSING
;IMGDAT
    if (navok) then begin
        NAVinf(0) = IMGstr.sline
        NAVinf(1) = IMGstr.spix
        NAVinf(2) = IMGstr.cen_lin * 10.
        NAVinf(3) = IMGstr.cen_pix * 10.
        NAVinf(4) = IMGstr.linres
        NAVinf(5) = IMGstr.pixres
        NAVinf(6) = IMGstr.linang*1.e9
        NAVinf(7) = IMGstr.pixang*1.e9
        NAVinf(8) = ORBstr.sper*1e6 ;Seconds per revolution*10^6
        
        NAVinf( 9) = 10
        NAVinf(10) = ORBstr.ep_date
        NAVinf(11) = ORBstr.ep_time
        NAVinf(12) = ORBstr.ep_msec
        NAVinf(13) = ORBstr.semima*100.
        NAVinf(14) = ORBstr.incl * 1000.
        NAVinf(15) = ORBstr.eccen*1e6
        NAVinf(16) = ORBstr.meana*1.e3
        NAVinf(17) = ORBstr.rgtasc*1.e3
        NAVinf(18) = ORBstr.perigee*1.e3
        
;Second set of kepler elements
        NAVinf(19:28) = MISSING
;Third set of kepler elements
        NAVinf(29:38) = MISSING
;ATTDAT
        NAVinf(39) = round(ATTstr.roll * 1.e6)
        NAVinf(40) = -round(ATTstr.pitch* 1.e6)
        NAVinf(41) = round(ATTstr.yaw  * 1.e6)
;ATTFIT
        NAVinf(42:48) = MISSING
;RECINFO
        NAVinf(49:51) = MISSING
;FITINFO
        NAVinf(52:56) = MISSING
;POSDAT
        NAVinf(57) = p(0)
        NAVinf(58) = p(1)
        NAVinf(59) = p(6)
        NAVinf(60) = p(7)
        NAVinf(61) = p(8)
        NAVinf(62) = p(9)
        NAVinf(63) = p(10)
        NAVinf(64) = p(11)
        NAVinf(65) = p(13)
        NAVinf(66) = p(14)
        NAVinf(67) = p(15)
        NAVinf(68) = p(16)
        NAVinf(69) = p(17)
        NAVinf(70) = p(18)
        NAVinf(71) = p(21)
        NAVinf(72) = p(22)
        NAVinf(73) = p(23)
        NAVinf(74) = p(24)
        NAVinf(75) = p(25)
        NAVinf(76:85) = p(36:45)
        NAVinf(86:96) = p(48:58)
        NAVinf(97:107) = p(60:70)
        NAVinf(108:118) = p(72:82)
        NAVinf(119) = p(102)
        NAVinf(120) = p(103)
        NAVinf(121) = p(104)
        NAVinf(122) = p(105)
        NAVinf(123) = p(106)
        NAVinf(124) = p(107)
        NAVinf(125) = p(109)
        NAVinf(126) = p(110)
        NAVinf(127) = p(117)
        NAVinf(128) = p(118)
        NAVinf(129) = p(119)
        
;LOCDAT
        NAVinf(130) = 31
        NAVinf(131) = IMGstr.sline
        NAVinf(132) = round(glat1c*1e6)
        NAVinf(133) = round(glon1c*1e6)
        NAVinf(134) = round(grad1c*1e3)
        NAVinf(137) = IMGstr.sline+IMGstr.nlin*IMGstr.linres
        NAVinf(138) = round(glat2c*1e6)
        NAVinf(139) = round(glon2c*1e6)
        NAVinf(140) = round(grad2c*1e3)
;MISC
        NAVinf(143) = 0         ;GOES-NEXT Flag=0
        NAVinf(144) = MISSING
        NAVinf(145) = MISSING
        NAVinf(146) = MISSING
        NAVinf(147) = IMGstr.frdate
        NAVinf(148) = IMGstr.frtime * 1000
        NAVinf(149) = IMGstr.nlin
        NAVinf(150) = IMGstr.npix
        NAVinf(151:199) = MISSING
    endif
; Line prefix information
;PREinf = intarr(nchan,20,areadir.nline)
    i=0
    PREinf(*,i++,*) = MISSING   ;relative scanline
    PREinf(*,i++,*) = MISSING ;absolute scan line
    PREinf(*,i++,*) = MISSING ;year
    PREinf(*,i++,*) = MISSING ;doy
    PREinf(*,i++,*) = MISSING ;HHMM
    PREinf(*,i++,*) = MISSING ;Sec
    PREinf(*,i++,*) = MISSING ;MSec
    PREinf(*,i++,*) = MISSING   ;eastern edge of earth
    PREinf(*,i++,*) = MISSING   ;western edge of earth
    PREinf(*,i++,*) = MISSING   ;detector ID
    ii=i++
    for j=0,ny-1 do begin
        ;PREinf(*,ii,j) = fix(swap_endian(long(lin(0:3,j),0,1)))
        PREinf(*,ii,j) = fix(swap_endian(long(lin(j).val,0,1)))
    endfor
    PREinf(*,i++,*) = total(image,2) mod 256 ;checksum
    TGRinf = 0
    b1u = {rev:REVinf,$
           img:IMGinf,$
           sat:SATinf,$
           nav:NAVinf,$
           pre:PREinf,$
           tgr:TGRinf,$
           image:image}      
;
; END B1U array definitions
;---------------------------------------------------
endif else begin
;==================================
; READER FOR 1996-1997 GAP
;==================================
;
; SET UP PARAMETERS
;
    EW_NAD_CY  = nav.ew_cyl
    EW_NAD_INC = nav.ew_inc
    NS_NAD_CY  = nav.ns_cyl
    NS_NAD_INC = nav.ns_inc
    bcd_time,nav.epoch_time,year,jday,hh,mm,sec,msec
    nye = long(year) & nde = long(jday)
    nhe = long(hh) & nme = long(mm)
    se = double(sec) + msec / 1000.d0
    imgdate = nav.img_date
    imgtime = nav.img_time / 1000
    ny = long(imgdate / 1000 ) + 1900l
    nd = long(imgdate mod 1000)
    nh = long(imgtime / 10000000)
    nm = long((imgtime / 100000) mod 100)
    s = double(imgtime mod 100000) / 1000.d0
    IMC = long(bittest(nav.imc_status,7))
    ew_offset = area.west_vis_elem
    ns_offset = area.north_bound
    line_res = area.line_res
    elem_res = area.elem_res
    
    cen_pix= (EW_NAD_CY*6136d0 + EW_NAD_INC) * 1d0 + 1.d0
    cen_lin= (NS_NAD_CY*6136d0 + NS_NAD_INC) * 8d0 / 28d0 + 4.5d0
    linres = line_res
    pixres = elem_res
    linang = 28.d-6 * 180.d0 / !dpi
    pixang = 16.d-6 * 180.d0 / !dpi
    sline = ns_offset
    spix =  ew_offset
    ;Set up the GVAR navigation header

    chninfo.nchan = 5
    chninfo.ch_name(0) = 'VSCHN'
    chninfo.ch_name(1) = 'IRNIR'
    chninfo.ch_name(2) = 'IRWVP'
    chninfo.ch_name(3) = 'IRWIN'
    chninfo.ch_name(4) = 'IRSPL'
    chninfo.ch_info = 'none'
    CHNstr = chninfo
    nchan = 5
;
; ASSIGN PARAMETERS TO STRUCTURES
;
    imginfo.frdate = imgdate
    imginfo.frtime = imgtime
    imginfo.cen_lin = cen_lin
    imginfo.cen_pix = cen_pix
    imginfo.linres = linres
    imginfo.pixres = pixres
    imginfo.nlin   = area.num_line
    imginfo.npix   = area.num_elem
    imginfo.sline  = sline
    imginfo.spix   = spix
    imginfo.linang = linang
    imginfo.pixang = pixang
    IMGstr = imginfo

    ATTstr = att

;---------------------------------------------------
;\_/\_/\_/\_/\_/\_/\_/\_/\_/\_/\_/\_/\_/\_/\_/\_/\_/
;
; BEGIN B1U array definitions
;
    MISSING = -9999l
    REVinf = strarr(6)
    IMGinf = lonarr(24)
    SATinf = strarr(34)
    NAVinf = lonarr(144)
    PREinf = intarr(nchan,20,IMGstr.nlin)

    ;REVISION INFORMATION
    REVinf(*) = 'Missing'
    REVinf(0) = stripname(file)
    REVinf(3) = b1ver

    ;IMAGE INFORMATION
    IMGinf(*) = MISSING
    IMGinf(0) = IMGstr.frdate
    IMGinf(1) = long(IMGstr.frtime)
    IMGinf(2) = MISSING         ;areadir.sss
    IMGinf(3) = IMGstr.nlin     ;areadir.nline
    IMGinf(4) = IMGstr.npix     ;areadir.nelem
    IMGinf(5) = nchan
    IMGinf(6) = 1               ;areadir.bytes
    IMGinf(7) = 1               ;N-S orientation
    IMGinf(8) = 0               ;E-W orientation
    IMGinf(9) = MISSING         ;Vis averaging: -999=MISSING
    IMGinf(10) = MISSING
    IMGinf(11) = AREA.val_code
    IMGinf(12) = 0              ;no image byte offset
    IMGinf(13) = 1              ;neither Imager or Sounder


    ;Satellite information
    i=0
    f = strsplit(stripname(file),'.',/extr)
    s = strsplit(f(3),'-',/extr)
    SATinf(*) = 'Missing'
    sn = fix(s(1))
    SATinf(i++) = 'GOES-'+s(1)
    SATinf(i++) = 'Imager'
    for j=0,nchan-1 do begin
        SATinf(i++) = chninfo.ch_name(j)
    endfor
    goes8info  = ['0.53-0.73 um','3.78-4.03 um','6.47-7.03 um','10.2-11.2 um','11.5-12.5 um']
    for j=0,nchan-1 do begin
        if (chninfo.ch_name(j) eq 'VSCHN') then tmp = goes8info(0)
        if (chninfo.ch_name(j) eq 'IRWIN') then tmp = goes8info(3)
        if (chninfo.ch_name(j) eq 'IRSPL') then tmp = goes8info(4)
        if (chninfo.ch_name(j) eq 'IRWVP') then tmp = goes8info(2)
        if (chninfo.ch_name(j) eq 'IRNIR') then tmp = goes8info(1)
        SATinf(i++) = tmp
    endfor

    ; TEST GRID
    TGRinf = MISSING

    ; Line prefix information
    ;PREinf = intarr(nchan,20,areadir.nline)
    PREinf(*) = MISSING
    i=0
    ny = IMGstr.nlin
    
    tagnames = tag_names(lin)
    docpresent=where(strpos(strupcase(tagnames),'DOC') ge 0)

    if (docpresent(0) ge 0) then begin

    b1 = lin.doc.bcdtime  /  16
    b2 = lin.doc.bcdtime mod 16
    iy = b1(0,*)*1000 + b2(0,*)*100 + b1(1,*)*10 + b2(1,*)
    idoy = b1(2,*)*100 + b2(2,*)*10 + b1(3,*)
    ihhmm= b2(3,*)*1000+ b1(4,*)*100+b2(4,*)*10+b1(5,*)
    isec = b2(5,*)*10 + b1(6,*)
    imsec =b2(6,*)*100 + b1(7,*)*10 + b2(7,*)

    PREinf(*,i++,*) = MISSING   ;relative scanline
    PREinf(*,i++,*) = rebin(reform(lin.doc.lindoc.relscan(1) + $
                                   lin.doc.lindoc.relscan(0) * 1024l, $
                                   1,1,ny),5,1,ny) ;linhdr.scnnum ;absolute scan line
    PREinf(*,i++,*) = MISSING
    PREinf(*,i++,*) = rebin(reform(iy,1,1,ny),5,1,ny)   ;year
    PREinf(*,i++,*) = rebin(reform(idoy,1,1,ny),5,1,ny) ;doy
    PREinf(*,i++,*) = rebin(reform(ihhmm,1,1,ny),5,1,ny);HHMM
    PREinf(*,i++,*) = rebin(reform(isec,1,1,ny),5,1,ny) ;Sec
    PREinf(*,i++,*) = rebin(reform(imsec,1,1,ny),5,1,ny);MSec
    PREinf(*,i++,*) = MISSING   ;eastern edge of earth
    PREinf(*,i++,*) = MISSING   ;western edge of earth
    PREinf(*,i++,*) = MISSING   ;detector ID
    PREinf(*,i++,*) = rebin(reform(fix(lin.val),1,1,ny),5,1,ny)   ;validity code
    PREinf(*,i++,*) = total(image,2) mod 256 ;checksum

    endif

    b1u = {rev:REVinf,$
           img:IMGinf,$
           sat:SATinf,$
           nav:{b1unav: NAV, b1uarea:AREA},$
           tgr:TGRinf,$
           pre:PREinf,$
           image:image}      

endelse
if keyword_set(debug) then stop
images=image
end

;***
