function get_z_score,inlat,inlon,inctype,b1u, $
                     subset=subset, $
                     iplot=iplot, $
                     center=center, $
                     ir=ir, $
                     vis=vis
lat=inlat
lon=inlon
ctype=inctype
if n_elements(subset) gt 0 then begin
    lat=lat(subset)
    lon=lon(subset)
    ctype=ctype(subset)
endif


b1u_ll2ij,lat,lon,imgi,imgj,nav=b1u.nav,center=center
if (n_elements(b1u.nav) gt 100) then begin
    glon = b1u.nav(133)/1e6
    if (b1u.nav(49) eq 1) then glon = b1u.nav(51)/1e3
    if (glon gt 180 or glon lt (-180)) then stop
endif else begin
    glon = b1u.nav.b1unav.ref_long / !dtor / 1e7
endelse
angles,lat,lon,0,0,sza,azn,vzaa,azia,/sat,inglon=glon+0.0001

ok = where(imgi gt 0 and imgj gt 0 and vzaa lt 70.,nok)
if (arg_present(subset)) then begin
    if (n_elements(subset) lt 1) then subset = ok
endif
s = size(b1u.image)
nx = s(2)
ny = s(3)
coast = bytarr(nx,ny)
irwin = intarr(nx,ny)
vschn = intarr(nx,ny)
vza   = intarr(nx,ny)
coast(imgi(ok),imgj(ok)) = ctype(ok)

iir = where(strtrim(b1u.sat,2) eq 'IRWIN',nir)-2
ivs = where(strtrim(b1u.sat,2) eq 'VSCHN',nvs)-2
if (nir gt 0) then begin
    irwin(imgi(ok),imgj(ok)) = b1u.image(iir(0)+imgi(ok)*0,imgi(ok),imgj(ok))
    vza(imgi(ok),imgj(ok)) = vzaa(ok)
endif else begin
;    Message,'How could IRWIN be missing?'
endelse

if keyword_set(iplot) then begin
;    window,0,xs=nx,ys=ny
endif

if (nvs gt 0) then begin
    vschn(imgi(ok),imgj(ok)) = b1u.image(ivs(0)+imgi(ok)*0,imgi(ok),imgj(ok))
    img = bytscl(vschn) 
endif else begin
    img = bytscl(vschn) 
endelse

;if keyword_set(iplot) then tvscl,img*(coast gt 1)

d=25

iscore=fltarr(nx,ny)
vscore=iscore

nbx = nx/d
nby = ny/d
use = intarr(nbx,nby)
num = use
vsz = fltarr(nbx,nby)
vsz(*) = 0.
irz = vsz
vsd = vsz
isd = vsz
for ib=0,nbx-1 do begin
    i1 = ib*d
    i2 = (ib+1)*d-1
    for jb=0,nby-1 do begin
        j1 = jb*d
        j2 = (jb+1)*d-1
        cpart = coast(i1:i2,j1:j2)
        ipart = irwin(i1:i2,j1:j2)
        vpart = vschn(i1:i2,j1:j2)
        num(ib,jb) = total(cpart gt 0)
        if (total(cpart gt 0) gt (d*d*0.16)) then begin
            l = where(cpart eq 2,nl)
            o = where(cpart eq 1,no)
            ;somewhat evenly distributed
            part = d*d*0.16*0.25
            if (no gt part and nl gt part) then begin
                sdmin = (1. / float(no)) < (1. / float(nl))
                vslmn = mean(vpart(l))
                vslsd = stdev(vpart(l)) > sdmin
                vsomn = mean(vpart(o))
                vsosd = stdev(vpart(o)) > sdmin
                
                irlmn = mean(ipart(l))
                irlsd = stdev(ipart(l)) > sdmin
                iromn = mean(ipart(o))
                irosd = stdev(ipart(o)) > sdmin

                vsd(ib,jb) = vslsd + vsosd
                isd(ib,jb) = irlsd + irosd

            ;   z score
                vz = (vslmn-vsomn) / $
                     sqrt((vslsd^2)/float(nl) + (vsosd^2)/float(no))
                iz = (irlmn-iromn) / $
                     sqrt((irlsd^2)/float(nl) + (irosd^2)/float(no))

                ;print,irlmn,irlsd,iromn,irosd,iz
                
                vsz(ib,jb) = vz
                irz(ib,jb) = iz
                
                iscore(i1:i2,j1:j2) = iz
                vscore(i1:i2,j1:j2) = vz
                                
            endif
        endif
    endfor
endfor
if keyword_set(iplot) then tvscl,img*(coast gt 0) * congrid(irz ne 0.,nx,ny)

if keyword_set(ir) then  return,total(abs(irz))    ;      +total(abs(vsz))
if keyword_set(vis) then return,total(abs(vsz))
end

function get_five_z,inb1u,lat,lon,ctype,oldx,oldy,oldz, $
                    step=step, $
                    last=last, $
                    subset=subset, $
                    center=center, $
                    ir=ir, $
                    vis=vis

if not(keyword_set(step)) then step = 1

;multiple of 10 because center line/pixel is scaled by 10
dx = [0, 0, 0, -10, 10] * step
dy = [0,-10, 10, 0,  0] * step

if (inb1u.img(13)) then begin
;however, starting line/pixel in GVAR is not scaled
    dx=dx/10
    dy=dy/10
endif

b1u=inb1u
useb1u=b1u

if n_elements(oldx) eq 0 then begin
    if (b1u.img(13)) then begin
        oldx = [b1u.nav.b1uarea.west_vis_elem]
        oldy = [b1u.nav.b1uarea.north_bound]
    endif else begin
        oldx = [b1u.nav(2)]
        oldy = [b1u.nav(3)]
    endelse
    oldz = [get_z_score(lat,lon,ctype,b1u,iplot=iplot,subset=subset,center=center,ir=ir,vis=vis)]
endif

;check same direction
if n_elements(last) eq 2 then begin

    if (b1u.img(13)) then begin
        prevx = b1u.nav.b1uarea.west_vis_elem
        prevy = b1u.nav.b1uarea.north_bound
    endif else begin
        prevx = b1u.nav(2)
        prevy = b1u.nav(3)
    endelse
    
;get current value
    w = where(prevx eq oldx and prevy eq oldy,nmatch)
    if (nmatch eq 1) then begin
        origz = oldz(w(0))
    endif else begin
        message,'The old value should be found'
    endelse

    if (b1u.img(13)) then begin
        newx = b1u.nav.b1uarea.west_vis_elem + last(0)
        newy = b1u.nav.b1uarea.north_bound + last(1)
    endif else begin
        newx = b1u.nav(2) + last(0)
        newy = b1u.nav(3) + last(1)
    endelse

    w = where(newx eq oldx and newy eq oldy,nmatch)

    if (nmatch eq 1) then begin
        newz = oldz(w(0))
    endif else begin
        useb1u=b1u
        if (b1u.img(13)) then begin
            useb1u.nav.b1uarea.west_vis_elem = newx
            useb1u.nav.b1uarea.north_bound   = newy
        endif else begin
            useb1u.nav(2) = newx
            useb1u.nav(3) = newy
        endelse
        oldx = [oldx,newx]
        oldy = [oldy,newy]
        newz = get_z_score(lat,lon,ctype,useb1u,iplot=iplot,subset=subset,center=center,ir=ir,vis=vis)
        oldz = [oldz,newz]
    endelse

    if (newz gt origz) then begin
;        print,'Stepping'
        return,last
    endif
endif


zz = fltarr(5)

for i=0,4 do begin
    useb1u=b1u
    if (b1u.img(13)) then begin
        newx = b1u.nav.b1uarea.west_vis_elem + dx(i)
        newy = b1u.nav.b1uarea.north_bound + dy(i)
        useb1u.nav.b1uarea.west_vis_elem = newx
        useb1u.nav.b1uarea.north_bound   = newy
    endif else begin
        newx = b1u.nav(2) + dx(i)
        newy = b1u.nav(3) + dy(i)
        useb1u.nav(2) = newx
        useb1u.nav(3) = newy
    endelse
;    print,'DIR',newx,newy
    w = where(newx eq oldx and newy eq oldy,nmatch)

    if (nmatch eq 1) then begin
        newz = oldz(w(0))
    endif else begin
        oldx = [oldx,newx]
        oldy = [oldy,newy]
;print,'USED===>',useb1u.nav(2:3)
        newz = get_z_score(lat,lon,ctype,useb1u,iplot=iplot,subset=subset,center=center,ir=ir,vis=vis)
        oldz = [oldz,newz]
    endelse
    zz(i) = newz
;    print,oldx,oldy
    if (i gt 0) then begin
        maxz = max(zz,maxloc)
        if (maxloc ne 0) then break
    endif
endfor

;print,'ZZ',zz
maxz = max(zz,maxloc)

last = [dx(maxloc),dy(maxloc)]
return,last

end


function maximize_z_score,inb1u,lat,lon,ctype, $
  center=center, $
  ir=ir, $
  vis=vis, $
  start=start

if keyword_set(start) then istart=start else istart=5

b1u=inb1u
b1unew=inb1u
if (b1u.img(13) eq 1) then begin
    message,'I do not know how to re-navigate GVAR data',/info
endif

;timer,/start

for istep=istart,1,-2 do begin
diff = 1.
last=0
;print,'STEP=',istep
while (diff ne 0) do begin
    chg = get_five_z(b1unew,lat,lon,ctype,remx,remy,remz, $
                     step=istep,last=last,subset=subset, $
                     center=center,ir=ir,vis=vis)
    diff = total(abs(chg))
    if (b1unew.img(13)) then begin
        b1unew.nav.b1uarea.west_vis_elem = b1unew.nav.b1uarea.west_vis_elem + chg(0)
        b1unew.nav.b1uarea.north_bound  = b1unew.nav.b1uarea.north_bound  + chg(1)
        var = [b1unew.nav.b1uarea.west_vis_elem,b1unew.nav.b1uarea.north_bound]
    endif else begin
        b1unew.nav(2) = b1unew.nav(2) + chg(0)
        b1unew.nav(3) = b1unew.nav(3) + chg(1)
        var = b1unew.nav(2:3)
    endelse
;    print,reform([chg,var])
endwhile

endfor
;timer,/stop,/print

;print,'Memory'
;for i=0,n_elements(remz)-1 do begin
;    print,i,remx(i),remy(i),remz(i)
;endfor

return,b1unew

end

;****I* idl/idl.b1u_coastline_navigation
; NAME
; b1u_coastline_navigation
; 
; PURPOSE
; To adjust the navigation by fitting to a coastline
; 
; USAGE
; INPUT
; OUTPUT
; RESULT
; EXAMPLE
; USES
;    (internal)
; * idl.get_five_z
; * idl.get_z_score
; * idl.maximize_z_score
;    (external)
; * angles.pro
; * b1u_ll2ij.pro
; * mean.pro
; * stdev.pro
; 
; USED BY
; * b1_2_b1u.pro
; 
; NOTES
; Uses the coastal file:
; getenv('DATDIR')+'/igbp/gigbp2_0ll.img.remap.10km.coast'
; 
; TODO
; 
; BUGS
; 
; AUTHOR
; Ken Knapp, NOAA/NCDC/RSAD
; 
; CREATION DATE
; 
; HISTORY
; 
; SOURCE

pro b1u_coastline_navigation,origb1u,center,iroff,visoff

b1u=origb1u

cfile = getenv('DATDIR')+'/igbp/gigbp2_0ll.img.remap.10km.coast'
np=0l
openr,1,cfile
readu,1,np
lat=fltarr(np)
lon=fltarr(np)
ctype=bytarr(np)
readu,1,lat
readu,1,lon
readu,1,ctype
close,1


iir = where(strtrim(b1u.sat,2) eq 'IRWIN',nir)-2
ivs = where(strtrim(b1u.sat,2) eq 'VSCHN',nvs)-2

if (nir gt 0) then begin

b1u_ir = maximize_z_score(b1u,lat,lon,ctype,center=center,/ir)

if (b1u_ir.img(13)) then begin 
    bef = [b1u.nav.b1uarea.west_vis_elem, b1u.nav.b1uarea.north_bound]
    aft = [b1u_ir.nav.b1uarea.west_vis_elem,b1u_ir.nav.b1uarea.north_bound]
endif else begin
    bef = b1u.nav(2:3)
    aft = b1u_ir.nav(2:3)        
endelse
iroff = aft-bef
print,'IROFF:',iroff

endif else begin
    iroff = [0,0]
    print,'Missing IRWIN data - no renavigation'
    b1u_ir = b1u
endelse
;map_results,b1u,b1u_ir,1,center=center,/tdf
;stop

if (nvs gt 0) then begin

b1u_vs = maximize_z_score(b1u_ir,lat,lon,ctype,center=center,/vis,start=3)

if (b1u_vs.img(13)) then begin 
    bef = [b1u.nav.b1uarea.west_vis_elem, b1u.nav.b1uarea.north_bound]
    aft = [b1u_vs.nav.b1uarea.west_vis_elem,b1u_vs.nav.b1uarea.north_bound]
endif else begin
    bef = b1u.nav(2:3)
    aft = b1u_vs.nav(2:3)        
endelse
visoff = aft-bef
print,'VSOFF:',visoff

endif else begin
    visoff = [0,0]
    print,'Missing VSCHN data - no renavigation'
endelse
;map_results,b1u_ir,b1u_vs,1,center=center,/tdf
;stop

end

;***
