;****I* idl/idl.b3file_from_b1file
; NAME
; b3file_from_b1file
; 
; PURPOSE
; Determine the name of the B3 file based on a b1 file
; 
; USAGE
; INPUT
; OUTPUT
; RESULT
; EXAMPLE
; USES
; * ftime.pro
; 
; USED BY
; * b3_channel_order.pro
; 
; NOTES
; TODO
; BUGS
; 
; AUTHOR
; Ken Knapp, NOAA/NCDC/RSAD
; 
; CREATION DATE
; ???
; HISTORY
; 2010-08 - krk - Added robodoc header
; 
; SOURCE

function b3file_from_b1file,b1file,exact=exact
file = b1file
f=strsplit(file,'.',/extr)

f(1) = 'B3'
f(2) = '?'
time = f(7)
t = ftime(time*100l)
b3t = (round(t / 3.) mod 8) * 300
f(7) = string(b3t,format='(i4.4)')
f(8) = '???'
;print,'time:',time
;print,'t:',t
;print,f
b3files = file_search(getenv('ISCCPDIR')+'b3/'+f(4)+'/ISCCP.'+strjoin(f(1:7),'.')+'.???.gz',$
                      count=nfiles)
b3file=''
if (nfiles gt 0) then begin
    b3file=b3files(0)
    return,b3file
endif else begin
    if keyword_set(exact) then return,''
    f(7) = '????'
    b3files = file_search(getenv('ISCCPDIR')+'b3/'+f(4)+'/ISCCP.'+strjoin(f(1:7),'.')+'.???.gz',$
                          count=nfiles)
    if (nfiles gt 0) then begin
        b3file=b3files(0)
        return,b3file
    endif else begin
        f(6) = '??'
        b3files = file_search(getenv('ISCCPDIR')+'b3/'+f(4)+'/ISCCP.'+strjoin(f(1:7),'.')+'.???.gz',$
                              count=nfiles)
        if (nfiles gt 0) then begin
            b3file=b3files(0)
            return,b3file
        endif else begin
            print,'No B3 file that month'
            return,''
        endelse
    endelse

endelse
    
end
;***
