;****I* idl/idl.bitprint
; NAME
; bitprint
; 
; PURPOSE
; To print out the bit values for a given integer
; 
; USAGE
; INPUT
; OUTPUT
; RESULT
; EXAMPLE
; USES
; * bittest.pro
; 
; USED BY
; * b1read_csu_g8.pro
; 
; NOTES
; TODO
; BUGS
; AUTHOR
; Ken Knapp, NOAA/NCDC/RSAD
; CREATION DATE
; Thu Dec  3 16:17:05 EST 2009
; HISTORY
; SOURCE

function bitprint,a

s=size(a)

type = s(1 + s(0))
if (type eq 1) then nbits=8 else if (type eq 2) then nbits=16 $
  else if (type eq 3) then nbits=32 else return,-1
bits = bytarr(nbits)
for i=nbits-1,0,-1 do begin
    bits(nbits-i-1) = bittest(a,i)
endfor
if (s(1) eq 1) then return,string(bits,format='(8i1,i7)') else $
if (s(1) eq 2) then return,string(bits,format='(2(8i1,1x),i7)') else $
if (s(1) eq 3) then return,string(bits,format='(4(8i1,1x),i7)')
end
;***
