;****I* idl/idl.bittest
; NAME
; bittest
; 
; PURPOSE
; To test whether a specific bit is set in an integer.
; 
; USAGE
; result = bittest(value,bit_number)
;
; where
; 
;          value = integer (byte, short or long)
;          bit_number = integer [0-7  for byte]
;                               [0-15 for short]
;                               [0-31 for long]
;          result = integer: 0 if set
;                            1 if not set
; 
; INPUT
; OUTPUT
; RESULT
; EXAMPLE
; IDL> print,bittest(3,0)
;   1
; IDL> print,bittest(3,1)
;   1
; IDL> print,bittest(3,2)
;   0
; USES
; Nothing
; 
; USED BY
; * bitprint.pro
; * b1read_cma_fy2.pro
; * b1read_csu_g8.pro
; * b1read_csu_g91012.pro
; * b1read_noa_goe.pro
; 
; NOTES
; TODO
; BUGS
; AUTHOR
; Ken Knapp, NOAA/NCDC/RSAD
; 
; CREATION DATE
; Unknown.
; 
; HISTORY
; * Jun2010 - added headers
; 
; SOURCE

function bittest,a,bit
if n_elements(bit) eq 0 then return,-1
s=size(a)

type = s(1 + s(0))
if (type eq 1) then nbits=8 else if (type eq 2) then nbits=16 $
  else if (type eq 3) then nbits=32 else return,-1
test=ishft(ishft(a,nbits-bit-1),-nbits+1)
return,byte(test)
end
;***
