;****I* idl/idl.btread
; NAME
; btread
; 
; PURPOSE
; To read ISCCP BT (calibration) files
; 
; USAGE
; INPUT
; OUTPUT
; RESULT
; EXAMPLE
; USES
; * reset.pro
; 
; USED BY
; * b1read_calv2.pro
; 
; NOTES
; TODO
; BUGS
; AUTHOR
; Ken Knapp, NOAA/NCDC/RSAD
; 
; CREATION DATE
; ???
; 
; HISTORY
; 
; SOURCE

pro btread,file,table,nchan=nchan
f=strsplit(file,'.',/extr)
n=n_elements(f) 
icomp=0
if (f(n-1) eq 'gz') then icomp=1
maxtab=6
maxchan=5
table=fltarr(maxtab,maxchan,256)

SATID=''
IDATE=0l
ICHAN=0l
IAVAIL=0l
ITIME1=0l
ITIME2=0l
tabflg=bytarr(maxtab)
in = fltarr(maxtab)

nchan=0
on_ioerror,badfile
openr,lun,file,comp=icomp,/get_lun
while not(eof(lun)) do begin
;C* READ A HEADER RECORD
    READf,lun,format='(A8,I9,2I2,2I7,6I2)', SATID,IDATE,ICHAN,IAVAIL,ITIME1,ITIME2,tabflg
;C* READ DATA RECORDS IF PRESENT                                                 
      IF ( IAVAIL NE 0 ) THEN begin
          nchan=nchan+1
          for ICOUNT=0,255 do begin
              READf,lun,format='(6F8.3)',in
              table(*,ichan-1,icount) = in
          endfor
      ENDIF                 
endwhile
close,lun
free_lun,lun
return

badfile:
close,lun
free_lun,lun
table=-1
nchan=0
return

end
;***
