;****I* idl/idl.const.pro
; NAME
; idl.const.pro
; 
; PURPOSE
; To initialize geophysical variables.
; 
; USAGE
; Usually included in routines as:
; @const.pro
; 
; INPUT
; OUTPUT
; RESULT
; EXAMPLE
; USES
; * Nothing
; 
; USED BY
; * cart2earth.pro
; * plot_tle.pro
; * b1u_ij2ll.pro
; * b1u_ll2ij.pro
; * kep2cart.pro
; 
; NOTES
; TODO
; BUGS
; AUTHOR
; Ken Knapp, NOAA/NCDC/RSAD
; 
; CREATION DATE
; ??
; HISTORY
; 2010-08 - KRK - Added robodoc header.
; 
; SOURCE

;common CONST, PI,rad, rot, gr_ang0, ae, be, gme, j2, ree

pi = !dpi
rad = 180.d0 / !dpi
ae = 6378.144d0
be = 6356.759d0
gme = 3.986005d14               ;m^3 / s^2
j2 = 1.08263d-3
ree = 6.378137d3                ;km
;***
