;****I* idl/idl.correlation
; NAME
; correlation
; 
; PURPOSE
; To calculate the linear correlation coefficient.
; 
; USAGE
; INPUT
; OUTPUT
; RESULT
; EXAMPLE
; USES
; * Nothing.
; 
; USED BY
; * cal_b1u_correct.pro
; 
; 
; NOTES
; Returns zero correlation if x or y do not vary enough.
; 
; TODO
; BUGS
; AUTHOR
; Ken Knapp, NOAA/NCDC/RSAD
; 
; CREATION DATE
; ???
; 
; HISTORY
; SOURCE

function correlation,x,y
sxx = total(double(x)*double(x))
sxy = total(double(x)*double(y))
syy = total(double(y)*double(y))
if (abs(sxx) lt 1.e-10 or abs(syy) lt 1.e-10) then return,0.
return,sxy/sqrt(sxx*syy)
end
;***
