;****I* idl/idl.def_oapre96
; NAME
; def_oapre96
; 
; PURPOSE
; To define a structure used in reading orbit and attitude data from
; older GOES data 
; 
; USAGE
; INPUT
; OUTPUT
; RESULT
; EXAMPLE
; USES
; * Nothing.
; 
; USED BY
; * b1read_oa.pro
; 
; NOTES
; TODO
; BUGS
; AUTHOR
; Ken Knapp, NOAA/NCDC/RSAD
; 
; CREATION DATE
; ???
; 
; HISTORY
; SOURCE

function def_oapre96
Sinu = {Sinusoid,$
        magnitude:0.d,$
        phs_ang:0.d}

Poly = {Polynomial,$
        order_app:0.d,$
        order_1st:0.d,$
        mag:0.d,$
        phs_ang:0.d,$
        ang_frm_epoch:0.d}

AM = {Attmis,$
      exp_mag:0.d,$
      exp_tim:0.d,$
      mn_att_ang:0.d,$
      num_sin:0.d,$
      sinusoids:replicate(Sinu,15),$
      num_mon_sin:0.d,$
      polynomial:replicate(poly,4)}

NadOff = {NadirOffset,$
          ns_nad_cy:0.d,$
          ew_nad_cy:0.d,$
          ns_nad_inc:0.d,$
          ew_nad_inc:0.d}
ESC = {ElevScanConst,$
       incmax:0.d,$
       elvinc:0.d,$
       scninc:0.d,$
       elvln:0.d,$
       scnpx:0.d}
CalDat = {Calibration,$
          lgain:0.d,$
          bias:0.d,$
          rad_to_alb:0.d,$
          rt_a:0.d,$
          rt_b:0.d}
;post 7/1996 is 2768 bytes (file = 2807 bytes) --- no calibration block
OApre96 = {OrbAttpre96,$
           IMC_flag:0.d,$
           rec_st_scn:0.d,$
           rec_st_pix:0.d,$
           rec_en_scn:0.d,$
           rec_en_pix:0.d,$
           ref_long:0.d,$
           ref_rad_dist_from_nom:0.d,$
           ref_lat:0.d,$
           ref_orb_yaw:0.d,$
           ref_roll:0.d,$
           ref_pitch:0.d,$
           ref_yaw:0.d,$
           bcd_epoch_time:dblarr(2),$
           start_time_from_epoch:0.d,$
           imc_roll:0.d,$
           imc_pitch:0.d,$
           imc_yaw:0.d,$
           delta_long:dblarr(13),$
           delta_rad_dist:dblarr(11),$
           sin_geo_lat:dblarr(9),$
           sin_orb_yaw:dblarr(9),$
           solar_rate:0.d,$
           exp_start_time_from_epoch:0.d,$
           att_miss:replicate(AM,5),$
           nadir_offsets:NadOff,$
           elvscn_const:ESC}
;post 7/1996 is 2968 bytes (file = 3007 bytes)
OApost96 = {OrbAttpost96,$
            IMC_flag:0.d,$
            rec_st_scn:0.d,$
            rec_st_pix:0.d,$
            rec_en_scn:0.d,$
            rec_en_pix:0.d,$
            ref_long:0.d,$
            ref_rad_dist_from_nom:0.d,$
            ref_lat:0.d,$
            ref_orb_yaw:0.d,$
            ref_roll:0.d,$
            ref_pitch:0.d,$
            ref_yaw:0.d,$
            bcd_epoch_time:dblarr(2),$
            start_time_from_epoch:0.d,$
            imc_roll:0.d,$
            imc_pitch:0.d,$
            imc_yaw:0.d,$
            delta_long:dblarr(13),$
            delta_rad_dist:dblarr(11),$
            sin_geo_lat:dblarr(9),$
            sin_orb_yaw:dblarr(9),$
            solar_rate:0.d,$
            exp_start_time_from_epoch:0.d,$
            att_miss:replicate(AM,5),$
            nadir_offsets:NadOff,$
            elvscn_const:ESC,$
            cal_data:replicate(CalDat,5)}

return,oapre96
end

;***
