;****I* idl/idl.define_mcidas_area_gvar
; NAME
;  define_mcidas_area_gvar
; PURPOSE
; Set up the McIDAS AREA structure for the GVAR files.
; USAGE
; from mcidas_read.pro
; define_mcidas_area_gvar,AREAstr
; NOTES
; Derived from McIDAS documentation:
; http://www.ssec.wisc.edu/mcidas/doc/misc_doc/area2.html
; USED BY
; * mcidas_read.pro
; AUTHOR
; Ken Knapp, NOAA/NCDC/RSAD
; CREATION DATE
; ???
; HISTORY
; * 27 Jun07 - Added documentation
; SOURCE

pro define_mcidas_area_gvar,AREAstr
AREAstr = { AREAg9,               $
            area_status:0L,$    ; Area status
            version_num:0L,$    ; Area version number
            sat_id_num:0L,$     ; Satellite ID (SSS)
            img_date:0L,$       ; Year and Julian day (YYDDD)
            img_time:0L,$       ; Time of image (HHMMSS)
            north_bound:0L,$    ; Upper left line in Sat coords (Y-Coord)
            west_vis_elem:0L,$  ; Upper left element in Sat coords (X-Coord)
            z_coor:0L,$         ; Upper z-coord (Z-Coord)
            num_line:0L,$       ; Number of lines in image (Y-SIZE)
            num_elem:0L,$       ; Number of elememts in image (X-SIZE)
            bytes_per_pixel:0L, $ ; Number of bytes per data element
            line_res:0L,$       ; Line resolution (Y-RES)
            elem_res:0L,$       ; Element resolution (X-RES)
            num_chan:0L,$       ; Number of bands (Z-RES)
            num_byte_ln_prefix:0L,      $ ; Number of bytes in line prefix (multiple of 4)
            proj_num:0L,$       ; Project number
            creation_date:0L,$  ; Creation date (YYYDDD)
            creation_time:0L,$  ; Creation time (HHMMSS)
            sndr_filter_map:0L,$ ; Filter map for soundings
            img_id_num:0L,$     ; Image ID number
            id:lonarr(4),$      ; Reserved for radar appications
            ;comment:string(' ',format='(a32)'), $ ; 32 char comments
            comment:bytarr(32),$ ;32 byte ASCII comments
            pri_key_calib:0L,$  ; Calibration colicil (area number)
            pri_key_nav:0L,$    ; Primary navigation codicil  (data)
            sec_key_nav:0L,$    ; Secondary navigation codicil (nav)
            val_code:0L,$       ; Validity code
            pdl:lonarr(8),$     ; PDL in packed-byte format
            band8:0L,$          ; Where band-8 came from
            act_img_date:0L,$   ; Actual image start day (YYYDDD)
            act_img_time:0L,$   ; Actual image start time (HHMMSS)
            act_start_scan:0L,$ ; Actual start scan
            len_prefix_doc:0L,$ ; Length of prefix documentation (DOC)
            len_prefix_calib:0L,$ ; Length of prefix calibration (CAL)
            len_prefix_lev:0L,$ ; Length of prefix level (LEV)
            src_type:bytarr(4),$ ; Source type
            calib_type:bytarr(4),$ ; Calibration type
            avg_or_sample:0L,$  ; Data was averaged (0) or sampled (1)
            poes_signal:0L,$    ; LAC, GAC, HRPT
            poes_up_down:0L,$   ; POES ascending/descending
            orig_src_type:bytarr(4),$ ; Original source type of data
            reserved:lonarr(7)} ; Reserved (6 calib pointer)


end
;***
