;****I* idl/idl.define_mcidas_lineprefix_class
; NAME
;  define_mcidas_lineprefix_class
; PURPOSE
; Set up the structure for the line prefixes produced by NOAA/CLASS.
; USAGE
; from mcidas_read.pro
; define_mcidas_lineprefix_class,class_pre
; NOTES
; Derived from McIDAS documentation:
; http://www.ssec.wisc.edu/mcidas/doc/misc_doc/area2.html
; USED BY
; * mcidas_read.pro
; AUTHOR
; Ken Knapp, NOAA/NCDC/RSAD
; CREATION DATE
; ???
; HISTORY
; * 27 Jun07 - Added documentation
; SOURCE

pro define_mcidas_lineprefix_class,class_prefix
class_lindoc = {spcid:0, $
                spsid:0, $
                lside:0, $
                lidet:0, $      ;detector number (used for calibration)
                chan:0, $
                relscan:intarr(2), $ ;scan = relscan(0)*1024 + relscan(1)
                l1scan:0, $
                l2scan:0, $
                lpixls:intarr(2), $
                lwords:intarr(2), $
                lzcor:0, $
                llag:0, $
                spare:0}
class_bh = {id:0b, $
            wsize:0b, $
            wcount:0, $
            pid:0, $
            rflag:0b, $
            version:0b, $
            valid:0b, $
            ascii:0b, $
            spare1:0b, $
            range:0b, $
            bcount:0, $
            spare2:0, $
            spstime:bytarr(8), $
            spare3:0l, $
            errchk:0}
class_b0 = {spcid:0b, $
            spsid:0b, $
            iscan:0l, $
            idsub:bytarr(16), $
            tcurr:bytarr(8), $
            tched:bytarr(8), $
            tctrl:bytarr(8), $
            tlhed:bytarr(8), $
            tltrl:bytarr(8), $
            tipfs:bytarr(8), $
            tinfs:bytarr(8), $
            tispc:bytarr(8), $
            tiecl:bytarr(8), $
            tibbc:bytarr(8), $
            tistr:bytarr(8), $
            tlran:bytarr(8), $
            tiirt:bytarr(8), $
            tivit:bytarr(8), $
            tclmt:bytarr(8), $
            tiona:bytarr(8)}
            

class_prefix = {crc:bytarr(2),$
                scanstat:bytarr(4), $
                bcdtime:bytarr(8), $
                blkhdr:class_bh, $
                lindoc:class_lindoc, $
                block0:class_b0, $
                spare: bytarr(2)}


end
;***
