;****I* idl/idl.define_mcidas_nav_gvar
; NAME
; define_mcidas_nav_gvar
; PURPOSE
; Set up the McIDAS navigation structure for the GVAR files.
; USAGE
; from mcidas_read.pro
; define_mcidas_nav_gvar,NAVstr
; NOTES
; Derived from McIDAS documentation:
; http://www.ssec.wisc.edu/mcidas/doc/misc_doc/area2.html
; USED BY
; * mcidas_read.pro
; 
; AUTHOR
; Ken Knapp, NOAA/NCDC/RSAD
; 
; CREATION DATE
; ???
; 
; HISTORY
; * 27 Jun07 - Added documentation
; 
; SOURCE

pro define_mcidas_nav_gvar,NAVstr
IMGR_SIN = { IMGR_SIN, mag_sinu:0L, phase_ang_sinu:0L }
IMGR_MON = { IMGR_MON,            $
             order_appl_sinu:0L,  $
             order_mono_sinu:0L,  $
             mag_mono_sinu:0L,    $
             phase_ang_sinu:0L,   $
             ang_from_epoch:0L    }
IMGR_REP = { IMGR_REP,                        $
             exp_mag:0L,                      $
             exp_time_const:0L,               $
             mean_att_ang_const:0L,           $
             num_sinu_per_angle:0L,           $
             sinusoid:REPLICATE(IMGR_SIN,15), $
             num_mono_sinu:0L,                $
             monomial:REPLICATE(IMGR_MON,4)   }
NAVstr = { NAVstr,                          $
           nav_type:bytarr(4), $
           ID:bytarr(4),    $
           IMC_status:0L,                   $
           Flip:0L,                         $
           spare1:0L,                       $
           ref_long:0L,                     $
           ref_rad_dist:0L,                 $
           ref_lat:0L,                      $
           ref_orb_yaw:0L,                  $
           ref_att_roll:0L,                 $
           ref_att_pitch:0L,                $
           ref_att_yaw:0L,                  $
           epoch_time:BYTARR(8),            $ ; BCD_TIME
           start_time:0L,                   $
           IMC_corr_roll:0L,                $
           IMC_corr_pitch:0L,               $
           IMC_corr_yaw:0L,                 $
           ref_long_change:LONARR(13),      $
           ref_rad_dist_change:LONARR(11),  $
           sine_lat:LONARR(9),              $
           sine_orb_yaw:LONARR(9),          $
           solar_rate:0L,                   $
           exp_start_time:0L,               $
           roll_att:IMGR_REP,               $
           spare2:LONARR(10),               $
           more1:bytarr(4), $
           gvar1:bytarr(4), $
           pitch_att:IMGR_REP,              $
           yaw_att:IMGR_REP,                $
           spare3:LONARR(16),               $
           more2:bytarr(4), $
           gvar2:bytarr(4), $
           roll_misalgn:IMGR_REP,           $
           pitch_misalgn:IMGR_REP,          $
           img_date:0L,                     $
           img_time:0L,                     $
           instr:0L,                        $
           spare4:LONARR(9),                $
           ns_cyl:0L,                       $
           ew_cyl:0L,                       $
           ns_inc:0L,                       $
           ew_inc:0L,                       $
           more3:bytarr(4), $
           gvar3:bytarr(4), $
           spare5:LONARR(126),              $
           more4:bytarr(4), $
           gvar4:bytarr(4), $
           spare6:LONARR(127)               }


end
;***
