;****I* idl/idl.elcons
; NAME
; elcons
; 
; PURPOSE
; To allow set constants for GVAR/IMC navigation routines
; 
; USAGE
; 
; @elcomm.pro
;
; This inserts the statements herein into the files.
; 
; INPUT
; OUTPUT
; RESULT
; EXAMPLE
; See files in "USED BY"
; 
; USES
; Nothing
; 
; USED BY
; * b1u_imc.pro
; * gpoint.pro
; * lmodel.pro
; * lpoint.pro
; * setcon.pro
; 
; NOTES
; TODO
; BUGS
; AUTHOR
; Ken Knapp, NOAA/NCDC/RSAD
; 
; CREATION DATE
; Unknown
; 
; HISTORY
; * Jun2010 - Added header
; 
; SOURCE

pi = 3.141592653589793D0
DEG=180.D0/PI
RAD=PI/180.D0
NOMORB=42164.365D0
AE=6378.137D0
FER=1.D0-(6356.7533D0/AE)
AEBE2=1.D0/(1.D0-FER)^2
AEBE3=AEBE2-1.
AEBE4=(1.D0-FER)^4-1.

;***
