;****I* idl/idl.equiv_ken
; NAME
; equiv_ken
; 
; PURPOSE
; To perform the same operation as the old EQUIVALENCE Fortran
; function. In essence, it can convert between dta types using the low
; level byte values.
; 
; USAGE
; INPUT
; OUTPUT
; RESULT
; EXAMPLE
; USES
; * Nothing.
; 
; USED BY
; * b1read_uws_g56.pro
; 
; NOTES
; TODO
; BUGS
; AUTHOR
; Ken Knapp, NOAA/NCDC/RSAD
; 
; CREATION DATE
; ???
; 
; HISTORY
; SOURCE

function equiv_ken,in_,tobyte=tobyte,tointeger=tointeger,$
    tolong=tolong,tostring=tostring

in=in_

s = size(in)
type = s(s(0)+1)
;type:  1 = byte
;       2 = int
;       3 = long
;       4 = real
;       5 = double

nin = long(product(s(1:1+s(0)-1)))
in1 = reform(in,nin)

if (keyword_set(tobyte)) then begin
    if (type eq 1) then return,in_ else $  ;byte->byte
    if (type eq 2) then begin          ;int->byte
        nout = nin * 2l
        out = bytarr(nout)
        i = lindgen(nin)*2l
        out(i) = byte(ishft(in,-8))
        out(i+1)=byte(in)
    endif else if (type eq 3) then begin ;lon -> byte
        nout = nin * 4l
        out = bytarr(nout)
        i = lindgen(nin)*4l
        out(i) = byte(ishft(in,-8*3))
        out(i+1)=byte(ishft(in,-8*2))
        out(i+2)=byte(ishft(in,-8*1))
        out(i+3)=byte(ishft(in,-8*0))
    endif else return,-1
endif else if keyword_Set(tointeger) then begin
    if (type eq 1) then begin   ;byte -> int
       nout = nin / 2
        out = intarr(nout)
        i = lindgen(nout)*2
        out = ishft(fix(in(i)),8) + fix(in(i+1))
    endif else if (type eq 2) then begin
       return,in_
    endif else if (type eq 3) then begin ;long - > int
       nout = nin * 2l
        out = intarr(nout)
        i = lindgen(nin)*2
        out(i) = fix(ishft(in,-16))
        out(i+1)=fix(in)
;        stop
    endif else return,-1
endif else if keyword_Set(tolong) then begin
    if (type eq 1) then begin ;byte -> long
       nout = nin / 4
        out = lonarr(nout)
        i = lindgen(nout)*4
        out = ishft(long(in(i)),24) + $
              ishft(long(in(i+1)),16) + $
              ishft(long(in(i+2)), 8) + $
                    long(in(i+3))

    endif else if (type eq 2) then begin ;int -> long
       nout = nin / 2
        out = lonarr(nout)
        out = lonarr(nout)
        i = lindgen(nout)*2
        out = ishft(long(in(i)),16) + $
                    long(in(i+1))
    endif else if (type eq 3) then return,in_ else return,-1
endif else if keyword_Set(tostring) then begin
    case type of
       1: return,in_
       2: nout = nin * 2l
       3: nout = nin * 4l
       4: nout = nin * 4l
       else: return,-1
    end
    out = strarr(nout)
endif else begin
    print,'Need an output type'
endelse

;stop
return,out
end
;***
