;****I* idl/idl.evln
; NAME
; evln
; 
; PURPOSE
;  THIS FUNCTION CONVERTS FRACTIONAL LINE NUMBER TO ELEVATION ANGLE
;  IN RADIANS.
; 
; USAGE
; 

; INPUT
; OUTPUT
; RESULT
; EXAMPLE
; See files in "USED BY"
; 
; USES
; * instco.pro
; 
; USED BY
; * b1u_imc.pro
; 
; NOTES
; TODO
; BUGS
; AUTHOR
; Ken Knapp, NOAA/NCDC/RSAD
; 
; CREATION DATE
; Unknown
; 
; HISTORY
; * Jun2010 - Added header
; 
; SOURCE

function evln,instr,rline

@instco.pro

IF (INSTR EQ 1) THEN begin
    EVLN=ELVMAX(INSTR-1)*1.0D0 - (RLINE-4.5d0)*(ELVLN(INSTR-1)*1.0D0)
endif else begin
    EVLN=ELVMAX(INSTR-1)*1.0D0 - (RLINE-2.5D0)*(ELVLN(INSTR-1)*1.0D0)
ENDelse
RETURN,evln
END

;***
