;****I* idl/idl.evsc2l
; NAME
; evsc2l
; 
; PURPOSE
; THIS SUBROUTINE CONVERTS ELEVATION AND SCAN ANGLES
; TO THE FRACTIONAL LINE AND PIXEL NUMBERS.
; 
; USAGE
; 

; INPUT
; OUTPUT
; RESULT
; EXAMPLE
; See files in "USED BY"
; 
; USES
; * instco.pro
; 
; USED BY
; * b1u_imc.pro
; 
; NOTES
; TODO
; BUGS
; AUTHOR
; Ken Knapp, NOAA/NCDC/RSAD
; 
; CREATION DATE
; Unknown
; 
; HISTORY
; * Jun2010 - Added header
; 
; SOURCE

pro evsc2l,instr,elev,scan,rl,rp

;instr: INSTRUMENT CODE (1-IMAGER, 2-SOUNDER)                   
@instco.pro
RL=(ELVMAX(INSTR-1)-ELEV)/ELVLN(INSTR-1)
IF (INSTR EQ 1) THEN begin
    RL=RL+4.5D0
endif ELSE begin 
    RL=RL+2.5D0
ENDelse
;C     COMPUTE FRACTIONAL PIXEL NUMBER
RP=(SCNMAX(INSTR-1)+SCAN)/SCNPX(INSTR-1)+1.0D0
end

;***
