;****I* idl/idl.ftime
; NAME
; ftime
; 
; PURPOSE
; To convert hhmmss to decimal (fractional) time
; 
; USAGE
; INPUT
; OUTPUT
; RESULT
; EXAMPLE
; USES
; * Nothing.
; 
; USED BY
; * yyjjj_2_julday.pro
; * b3file_from_b1file.pro
; * b1read_csu_met3.pro
; * b1read_eum_met.pro
; * b1read_eum_msg.pro
; * b1read_jma_gms.pro
; * b1read_jma_mts.pro
; * b1read_noa_goe.pro
; * b1read_uws_g56.pro
; * b1u_get_center.pro
; * hirs_b1u_month.pro
; * b1u_ij2ll.pro
; * b1u_ll2ij.pro
; 
; NOTES
; TODO
; BUGS
; AUTHOR
; Ken Knapp, NOAA/NCDC/RSAD
; 
; CREATION DATE
; ???
; 
; HISTORY
; SOURCE

function ftime,time
;returns decimal time from hhmmss
itime = long(time)
hh = itime / 10000l
mm = itime / 100l mod 100.
ss = itime mod 100.
return,double(hh) + double(mm)/60. + double(ss)/3600.
end

;***
