#!/bin/bash
#****x* /gridsat.make_cdr_files.sh
# NAME
#  gridsat.make_cdr_files.sh
# PURPOSE
# USAGE
# INPUT
# OUTPUT
# RESULT
# EXAMPLE
# USES
# USED BY
# NOTES
# TODO
# BUGS
# AUTHOR
# Ken Knapp, NOAA/NCDC/RSAD
# CREATION DATE
# Tue Aug 31 09:06:21 EDT 2010
# HISTORY
# SOURCE

BASE=/home/kknapp

GDIR=$BASE/datasan/grisat/
OUTDIR=$BASE/datasan/gridsat-irwin/
NCKS=$BASE/apps/bin/ncks


for year in `seq 1980 2009`
do
  cd $GDIR/$year
  for file in `ls GRISAT-B1.*.beta.nc`
  do
    fil=`basename $file`
    OUTFILE=`echo $fil | \
             sed 's/GRISAT/GridSat/' | \
             sed 's/beta/beta.irwin/'`
    echo $OUTFILE
    $NCKS -4 -L 6 -a -v irwin,satlat,satlon,satrad,satname,b1ufile,calslp_irwin,caloff_irwin,satid_ir \
	$file -O $OUTDIR/$year/$OUTFILE

  done

done



#***


