;****I* idl/idl.itime
; NAME
; itime
; PURPOSE
;       FLOATING POINT TIME TO PACKED INTEGER (SIGN HH MM SS)
;       INPUT PARAMETERS: 
; USAGE
; INPUT
;  X=FLOATING POINT TIME (fractional hours of the day)
; OUTPUT
; RESULT
; EXAMPLE
; USES
; * Nothing.
; 
; USED BY
; * b1read_aes_g7.pro
; * cheb2cart.pro
; * navcheck.pro
; * yyjjj_2_julday.pro
; * ftime.pro
; * plot_tle.pro
; * cma_bestfit.pro
; * b1read_csu_g6.pro
; * b1read_csu_g7.pro
; * b1read_csu_met3.pro
; * b1read_eum_met.pro
; * b1read_eum_msg.pro
; * b1read_jma_gms.pro
; * jma_bestfit.pro
; * b1read_noa_goe.pro
; * b1read_uws_g56.pro
; * cal_b1u_monthly.pro
; 
; 
; NOTES
; TODO
; BUGS
; AUTHOR
; Ken Knapp, NOAA/NCDC/RSAD
; CREATION DATE
; Thu Dec  3 16:17:05 EST 2009
; HISTORY
; SOURCE

function itime,x
hh = floor(x)
mm = floor((x*60l) mod 60.d0)
ss = floor((x*60l*60l) mod 60.d0)
itime = hh*10000l + mm*100l + ss
return,long(itime)
end
;***
