;****I* idl/idl.kploterror
; NAME
; kploterror
; 
; PURPOSE
; To plot error bars on values.
; 
; USAGE
; INPUT
; OUTPUT
; RESULT
; EXAMPLE
; USES
; * mean.pro
; * stdev.pro
; 
; USED BY
; * cal_b1u_monthly.pro
; 
; NOTES
; TODO
; BUGS
; AUTHOR
; Ken Knapp, NOAA/NCDC/RSAD
; 
; CREATION DATE
; ???
; 
; HISTORY
; SOURCE

pro kploterror,x,err, $
               min=min, $
               max=max, $
               ymin = ymin, $
               ymax = ymax, $
               binsize=binsize, $
               nbin=nbin, $
               point_color=point_color, $
               overplot=overplot, $
               _extra=extra, $
               linesonly=linesonly, $
               nozero=nozero, $
               integer=integer


if keyword_set(min) then amin=min else amin=min(x)
if keyword_set(max) then amax=max else amax=max(x)
if keyword_set(binsize) then begin 
    abins=binsize
endif else if keyword_set(nbin) then begin
    abins = (amax-amin)/float(nbin)
endif else begin 
    abins = (amax-amin)/20.
endelse 
if keyword_set(linesonly) then psym=-3

if keyword_set(integer) then begin
    h=histogram(x,rev=revind,locations=xind)
    abins=0.
endif else begin
    h=histogram(x,min=amin,max=amax,bins=abins,rev=revind,locations=xind)
endelse
n = n_elements(h) 
e = fltarr(n)
e(*) = -9.e8
b=e
for i=0,n-1 do begin
    if (h(i) gt 3) then begin
        e(i) = stdev(err(revind(revind(i):revind(i+1)-1)))
        b(i) = mean(err(revind(revind(i):revind(i+1)-1)))
    endif 
endfor

both = [b,e]
mxe = max(both)
mna = min(both(where(both gt -8e8)))
if keyword_set(ymin) then mna = ymin
if keyword_set(ymax) then mxa = ymax

if keyword_set(overplot) then begin 
    oplot,xind+abins/2.,e,min=-8e8,_extra=extra
endif else begin
    plot,xind+abins/2.,e,min=-8e8, $
         xrange=[amin,amax],xs=1,_extra=extra, $
         yrange=[mna,mxe],ys=1    
endelse

if keyword_set(linesonly) then begin
    if not(keyword_set(nozero)) then oplot,xind+abins/2.,b*0.
    ;the following fixes the thickness of the bias line to 1
    if n_elements(extra) eq 1 then begin
        if n_elements(extra.thick) eq 1 then begin
            extra.thick=1
        endif
    endif
    oplot,xind+abins/2.,b,_extra=extra,min=-8e8,lines=0,thick=1
endif else begin
    if not(keyword_set(nozero)) then oplot,xind+abins/2.,b*0.
    oplot,xind+abins/2.,b,psym=-6,_extra=extra,min=-8e8
endelse

end
;***
