;****I* idl/idl.navtorec
; NAME
; navtorec
; 
; PURPOSE
; To convert NAV AREA header to a rec array ( a double array)
; 
; USAGE
; INPUT
; MCIDAS Navigation array structure.
; 
; OUTPUT
; rec = dblarr(337)
; 
; RESULT
; EXAMPLE
; USES
; * Nothing.
; 
; USED BY
; * b1read_csu_g91012.pro
; * b1u_imc.pro
; 
; NOTES
; TODO
; BUGS
; AUTHOR
; Ken Knapp, NOAA/NCDC/RSAD
; 
; CREATION DATE
; ???
; 
; HISTORY
; Jul2010 - KRK - Added robodoc headers.
; 
; SOURCE

pro navtorec,NAV,rec
rec = dblarr(337)
;UNSURE OF SOME OF THE SCALING
rec(5) = NAV.ref_long * 1.d-7
rec(6) = NAV.ref_rad_dist * 1.d-7
rec(7) = NAV.ref_lat * 1.d-7
rec(8) = NAV.ref_orb_yaw * 1.d-7
rec(9) = NAV.ref_att_roll * 1.d-7
rec(10) = NAV.ref_att_pitch * 1.d-7
rec(11) = NAV.ref_att_yaw * 1.d-7
;rec(12) = NAV.   epoch
;rec(13) = NAV.   epoch
rec(14) = NAV.start_time*1.d-2
rec(15) = NAV.imc_corr_roll * 1.d-7
rec(16) = NAV.imc_corr_pitch * 1.d-7
rec(17) = NAV.imc_corr_yaw * 1.d-7
rec(18:30) = NAV.ref_long_change * 1.d-7
rec(31:41) = NAV.ref_rad_dist_change * 1.d-7
rec(42:50) = NAV.sine_lat * 1.d-7
rec(51:59) = NAV.sine_orb_yaw * 1.d-7
rec(60) = NAV.solar_rate * 1.d-7
rec(61) = NAV.exp_start_time*1.d-2
st = 62
rec(st) = NAV.roll_att.exp_mag* 1.d-7
rec(st+1) = NAV.roll_att.exp_time_const*1.d-2
rec(st+2) = NAV.roll_att.mean_att_ang_const* 1.d-7
rec(st+3) = NAV.roll_att.num_sinu_per_angle
ind = st+ 4 + lindgen(15)*2
rec(ind) = NAV.roll_att.sinusoid(*).mag_sinu* 1.d-7
rec(ind+1) = NAV.roll_att.sinusoid(*).phase_ang_sinu* 1.d-7
rec(st+34) =  NAV.roll_att.NUM_MONO_SINU
ind = st + 35 + lindgen(4)*5
rec(ind) = NAV.roll_att.monomial(*).order_appl_sinu
rec(ind+1)=NAV.roll_att.monomial(*).ORDER_MONO_SINU
rec(ind+2)=NAV.roll_att.monomial(*).MAG_MONO_SINU* 1.d-7
rec(ind+3)=NAV.roll_att.monomial(*).PHASE_ANG_SINU* 1.d-7
rec(ind+4)=NAV.roll_att.monomial(*).ANG_FROM_EPOCH* 1.d-7
st = 117
rec(st) = NAV.pitch_att.exp_mag* 1.d-7
rec(st+1) = NAV.pitch_att.exp_time_const*1.d-2
rec(st+2) = NAV.pitch_att.mean_att_ang_const* 1.d-7
rec(st+3) = NAV.pitch_att.num_sinu_per_angle
ind = st+ 4 + lindgen(15)*2
rec(ind) = NAV.pitch_att.sinusoid(*).mag_sinu* 1.d-7
rec(ind+1) = NAV.pitch_att.sinusoid(*).phase_ang_sinu* 1.d-7
rec(st+34) =  NAV.pitch_att.NUM_MONO_SINU
ind = st + 35 + lindgen(4)*5
rec(ind) = NAV.pitch_att.monomial(*).order_appl_sinu
rec(ind+1)=NAV.pitch_att.monomial(*).ORDER_MONO_SINU
rec(ind+2)=NAV.pitch_att.monomial(*).MAG_MONO_SINU* 1.d-7
rec(ind+3)=NAV.pitch_att.monomial(*).PHASE_ANG_SINU* 1.d-7
rec(ind+4)=NAV.pitch_att.monomial(*).ANG_FROM_EPOCH* 1.d-7
st = 172
rec(st) = NAV.yaw_att.exp_mag* 1.d-7
rec(st+1) = NAV.yaw_att.exp_time_const*1.d-2
rec(st+2) = NAV.yaw_att.mean_att_ang_const* 1.d-7
rec(st+3) = NAV.yaw_att.num_sinu_per_angle
ind = st+ 4 + lindgen(15)*2
rec(ind) = NAV.yaw_att.sinusoid(*).mag_sinu* 1.d-7
rec(ind+1) = NAV.yaw_att.sinusoid(*).phase_ang_sinu* 1.d-7
rec(st+34) =  NAV.yaw_att.NUM_MONO_SINU
ind = st + 35 + lindgen(4)*5
rec(ind) = NAV.yaw_att.monomial(*).order_appl_sinu
rec(ind+1)=NAV.yaw_att.monomial(*).ORDER_MONO_SINU
rec(ind+2)=NAV.yaw_att.monomial(*).MAG_MONO_SINU* 1.d-7
rec(ind+3)=NAV.yaw_att.monomial(*).PHASE_ANG_SINU* 1.d-7
rec(ind+4)=NAV.yaw_att.monomial(*).ANG_FROM_EPOCH* 1.d-7
st = 172+55
rec(st) = NAV.roll_misalgn.exp_mag* 1.d-7
rec(st+1) = NAV.roll_misalgn.exp_time_const*1.d-2
rec(st+2) = NAV.roll_misalgn.mean_att_ang_const* 1.d-7
rec(st+3) = NAV.roll_misalgn.num_sinu_per_angle
ind = st+ 4 + lindgen(15)*2
rec(ind) = NAV.roll_misalgn.sinusoid(*).mag_sinu* 1.d-7
rec(ind+1) = NAV.roll_misalgn.sinusoid(*).phase_ang_sinu* 1.d-7
rec(st+34) =  NAV.roll_misalgn.NUM_MONO_SINU
ind = st + 35 + lindgen(4)*5
rec(ind) = NAV.roll_misalgn.monomial(*).order_appl_sinu
rec(ind+1)=NAV.roll_misalgn.monomial(*).ORDER_MONO_SINU
rec(ind+2)=NAV.roll_misalgn.monomial(*).MAG_MONO_SINU* 1.d-7
rec(ind+3)=NAV.roll_misalgn.monomial(*).PHASE_ANG_SINU* 1.d-7
rec(ind+4)=NAV.roll_misalgn.monomial(*).ANG_FROM_EPOCH* 1.d-7
st = 172+55+55
rec(st) = NAV.pitch_misalgn.exp_mag* 1.d-7
rec(st+1) = NAV.pitch_misalgn.exp_time_const*1.d-2
rec(st+2) = NAV.pitch_misalgn.mean_att_ang_const* 1.d-7
rec(st+3) = NAV.pitch_misalgn.num_sinu_per_angle
ind = st+ 4 + lindgen(15)*2
rec(ind) = NAV.pitch_misalgn.sinusoid(*).mag_sinu* 1.d-7
rec(ind+1) = NAV.pitch_misalgn.sinusoid(*).phase_ang_sinu* 1.d-7
rec(st+34) =  NAV.pitch_misalgn.NUM_MONO_SINU
ind = st + 35 + lindgen(4)*5
rec(ind) = NAV.pitch_misalgn.monomial(*).order_appl_sinu
rec(ind+1)=NAV.pitch_misalgn.monomial(*).ORDER_MONO_SINU
rec(ind+2)=NAV.pitch_misalgn.monomial(*).MAG_MONO_SINU* 1.d-7
rec(ind+3)=NAV.pitch_misalgn.monomial(*).PHASE_ANG_SINU* 1.d-7
rec(ind+4)=NAV.pitch_misalgn.monomial(*).ANG_FROM_EPOCH* 1.d-7
rec = rec(1:336)
end
;***
