;****I* idl/idl.read_match_poes
; NAME
; read_match_poes
; 
; PURPOSE
; To read the matchup files created by match_b1u_poes.pro
; 
; USAGE
; 
; INPUT
; None
;
; KEYWORDS
; file = filename to be read (input)
; b1u   = list of b1u files in this file (output)
; b2    = list of ISCCP B2 files in this file (output)
; L1C   = list of HIRS Level 1C files in this file (output)
; PathAS= list of HIRS PAthfinder All Sky files in this file (output)
; SSMI  = list of SSMI files in this file (output)
; 
; OUTPUT
; None.
; 
; RESULT
; None.
; 
; EXAMPLE
; 
; USES
; * Only IDL internal procedures.
; 
; USED BY
; * b1u_2_grisat.pro (among many other routines)
; 
; NOTES
; * Should be updated if match_b1u_poes.pro is ever changed.
; 
; TODO
; 
; BUGS
; 
; AUTHOR
; Ken Knapp, NOAA/NCDC/RSAD
; 
; CREATION DATE
; 
; HISTORY
; 
; SOURCE

pro read_match_poes,file=file, $
                    b1u=b1u, $
                    b2=b2, $
                    L1C=L1C, $
                    PathAS=PathAS, $
                    SSMI=SSMI

if n_elements(file) eq 0 then begin
    print,'No Match file provided'
    return
endif
a=''
openr,1,file

readf,1,nb1u
if (nb1u gt 0) then begin
b1u=strarr(nb1u)
for i=0,nb1u-1 do begin
    readf,1,a
    b1u(i) = a
endfor
endif

readf,1,nib2
if (nib2 gt 0) then begin
b2=strarr(nib2)
for i=0,nib2-1 do begin
    readf,1,a
    b2(i) = a
endfor
endif
  
readf,1,nl1c
if (nl1c gt 0) then begin
l1c=strarr(nl1c)
for i=0,nl1c-1 do begin
    readf,1,a
    l1c(i) = a
endfor
endif

readf,1,npathas
if (npathas gt 0) then begin
pathas=strarr(npathas)
for i=0,npathas-1 do begin
    readf,1,a
    pathas(i) = a
endfor
endif

readf,1,nssmi
if (nssmi gt 0) then begin
ssmi=strarr(nssmi)
for i=0,nssmi-1 do begin
    readf,1,a
    ssmi(i) = a
endfor
endif

close,1
end
;***
