;****I* idl/idl.remove_gz
; NAME
; remove_gz
; 
; PURPOSE
; To remove trailing ".gz" from input filenames
; 
; USAGE
; INPUT
; input - string (generally a filename)
; 
; OUTPUT
; Returns the filename with the gz suffix (if present) removed.
; 
; RESULT
; EXAMPLE
; USES
; * Nothing.
; 
; USED BY
; * b1read_oa.pro
; * cma_bestfit.pro
; * jma_bestfit.pro
; * b1_2_b1u.pro
; * b1u_2_grisat.pro
; 
; NOTES
; TODO
; BUGS
; AUTHOR
; Ken Knapp, NOAA/NCDC/RSAD
; 
; CREATION DATE
; ??
; 
; HISTORY
; SOURCE

function remove_gz,input
;Purpose: remove the gz extension if it exists, otherwise, keep the
;filename the same.

file=input
f=strsplit(file,'.',/extr)
nf=n_elements(f) 
if (f(nf-1) eq 'gz') then $
  return,strjoin(f(0:nf-2),'.') else $
  return,file
end
;***
