pro read_cmap,cfile,rmap,gmap,bmap,tmap

rmap=bytarr(256)
gmap=rmap
bmap=rmap
tmap=fltarr(256)
openr,1,cfile
a=''
for i=0,255 do begin
    readf,1,a
    q=strsplit(a,' ',/extr)
    rmap(i) = (q(0))
    gmap(i) = (q(1))
    bmap(i) = (q(2))
    tmap(i) = (q(4))
endfor
close,1

end

function assign_index,temp,tmap
s=size(temp)
nx=s(1)
ny=s(2)
if (nx gt 1000 or ny gt 1000) then begin
    img=replicate(0,nx,ny)
    for i=0,255 do begin
        img = temporary(img) + (tmap(i) gt temp)
    endfor
endif else begin
    scl = rebin(reform(tmap,1,1,256),nx,ny,256)
    ttemp = rebin(reform(temp,nx,ny,1),nx,ny,256)
    img = total(ttemp lt scl,3)
endelse
;stop
return,img

end


;****I* idl/idl.satellite_temp2image
; NAME
; satellite_temp2image
; 
; PURPOSE
; To convert temperatuer data (K) to indices for mapping satellite
; imagery. In particuler, this uses tables provided CIRA (John Knaff)
; and NRL (Jeff Hawkins).
; 
; USAGE
; INPUT
; OUTPUT
; RESULT
; EXAMPLE
; USES
; * Nothing.
; 
; USED BY
; * b1u_2_grisat.pro
; 
; NOTES
; Requires color table informaiton in:
; getenv('DATDIR')+'/hurricanes/colormaps/'
; - IR4.cmap
; - BD_IR.cmap
; - ssmi_vapor.rgb
; - 37h.rgb
; - 85h.rgb
; 
; TODO
; BUGS
; AUTHOR
; Ken Knapp, NOAA/NCDC/RSAD
; 
; CREATION DATE
; ???
; 
; HISTORY
; SOURCE

function satellite_temp2image,temp, $
  cira=cira, $
  bd=bd, $
  h2o=h2o, $
  t37h=t37h, $
  t85h=t85h, $
  cindex=cindex

;read in the appropriate color table
;default table is black/white
loadct,0,/sil
img = bytscl(-(temp>200<300))
;stop
coldir=getenv('DATDIR')+'/hurricanes/colormaps'
if keyword_set(cira) then begin
    cfile = coldir+'/IR4.cmap'
    read_cmap,cfile,rd,gn,bl,ir_temp
    img=assign_index(temp,ir_temp)
    cindex = ir_temp
endif else if keyword_set(bd) then begin
    cfile = coldir+'/BD_IR.cmap'
    read_cmap,cfile,rd,gn,bl,bd_temp
    img=assign_index(temp,bd_temp)
endif else if keyword_set(h2o) then begin
    vap = intarr(3,256)
    openr,lun,coldir+'/ssmi_vapor.rgb',/get_lun
    readf,lun,vap
    close,lun
    free_lun,lun

    bad = where(temp lt 150 or temp gt 300,nbad)
    out = round(((temp > 200. < 270.) - 200) / 70.  * 240.)
    if (nbad gt 0) then out(bad) = 254
    img = out
    rd = byte(reform(vap(0,*)))
    gn = byte(reform(vap(1,*)))
    bl = byte(reform(vap(2,*)))

endif else if keyword_set(t37h) then begin
    t37h = intarr(3,256)
    openr,lun,coldir+'/37h.rgb',/get_lun
    readf,lun,t37h
    close,lun
    free_lun,lun
    stop
endif else if keyword_set(t85h) then begin
    t85h = intarr(3,256)
    openr,lun,coldir+'/85h.rgb',/get_lun
    readf,lun,t85h
    close,lun
    free_lun,lun
    stop
endif
tvlct,rd,gn,bl


;stop
return,img







end
;***
