;****I* idl/idl.setcon
; NAME
; setcon
; 
; PURPOSE
; To set constants used in GVAR navigation
; 
; USAGE
; INPUT
; OUTPUT
; RESULT
; EXAMPLE
; USES
; * elcons.pro
; * elcomm.pro
; * instco.pro
; 
; USED BY
; * b1u_imc.pro
; 
; NOTES
; TODO
; BUGS
; AUTHOR
; Ken Knapp, NOAA/NCDC/RSAD
; 
; CREATION DATE
; Unknown
; 
; HISTORY
; Jun2010 - Added header info (KRK)
; 
; SOURCE

pro setcon,INSTR,NS_NAD_CY,NS_NAD_INC,EW_NAD_CY,EW_NAD_INC

@elcons.pro
@elcomm.pro
@instco.pro

;INCMAX(1)=6136
;INCMAX(2)=2805
incmax = [6136,2805]
;ELVINC(1)=8.0D-6
;ELVINC(2)=17.5D-6
elvinc = [8.0D-6,17.5D-6]
;SCNINC(1)=16.D-6
;SCNINC(2)=35.D-6
scninc = [16.D-6,35.D-6]
;ELVLN(1)=28.D-6
;ELVLN(2)=280.D-6
elvln = [28.D-6,280.D-6]
;SCNPX(1)=16.D-6
;SCNPX(2)=280.D-6
scnpx = [16.D-6,280.D-6]

;RECOMPUTE ELEVATION AND SCAN BIASES BASED ON USER INPUTS OF               
;CYCLES & INCREMENTS OBTAINED FROM GVAR
;ELVMAX(INSTR) = (NS_NAD_CY*INCMAX(INSTR)+NS_NAD_INC)*ELVINC(INSTR)
elvmax = dblarr(2)
scnmax = dblarr(2)
IF(INSTR EQ 1) THEN begin
    ELVMAX(INSTR-1)=(NS_NAD_CY*INCMAX(INSTR-1)+NS_NAD_INC)*ELVINC(INSTR-1)
endif ELSE begin
    ELVMAX(INSTR-1)=((9-NS_NAD_CY)*INCMAX(INSTR-1)-NS_NAD_INC) $
      *ELVINC(INSTR-1)
ENDelse

SCNMAX(INSTR-1) = (EW_NAD_CY*INCMAX(INSTR-1)+EW_NAD_INC)*SCNINC(INSTR-1)
end
;***
