;****I* idl/idl.sndelo
; NAME
; sndelo
; 
; PURPOSE
; ??
; 
; USAGE
; INPUT
; OUTPUT
; RESULT
; EXAMPLE
; USES
; * instco.pro
; * lpoint.pro
; 
; USED BY
; * b1u_imc.pro
; 
; NOTES
; TODO
; BUGS
; AUTHOR
; Ken Knapp, NOAA/NCDC/RSAD
; CREATION DATE
; Thu Dec  3 16:17:05 EST 2009
; HISTORY
; SOURCE

pro sndelo,CYEW,INCEW,CYNS,INCNS,SVEW,SVNS,DOFF,GEO

@instco.pro

;CONVERT THE MIRROR POSITION, GIVEN IN CYCLES AND INCREMENTS, TO           
;ELEVATION AND SCAN ANGLES                                                 
E=((CYNS-9)*INCMAX(2-1)+INCNS)*ELVINC(2-1)-ELVMAX(2-1)
S=(CYEW*INCMAX(2-1)+INCEW)*SCNINC(2-1)-SCNMAX(2-1)

;CORRECT ELEVATION AND SCAN ANGLES FOR SERVO ERRORS OBTAINING THE          
;TRUE MIRROR POINTING                                                      
E=E+SVNS                                                                  
S=S+SVEW
SINE=SIN(E)
COSE=COS(E)
H=-2.0D0*SCNPX(2-1)

;COMPUTE EARTH LOCATIONS FOR FOUR DETECTORS
for i=1,4 do begin ;DO 10 I=1,4
    ;COMPUTE POSITIONAL OFFSETS OF I-TH DETECTOR
    DE=(2.5-I)*ELVLN(2-1)+DOFF(I-1,2-1)
    DS=H+DOFF(I-1,1-1)
    ;COMPUTE ELEVATION AND SCAN ANGLES RELATED TO I-TH DETECTOR                
    ;AND CORRECT THEM FOR THE DETECTOR POSITIONAL OFFSETS                      
    ;EV=E+DOFF(I,2)
    ;SC=S+DOFF(I,1)
    ;CONVERT POSITIONAL OFFSETS TO ANGULAR OFFSETS AND
    ;CORRECT ELEVATION AND SCAN ANGLES
    EV = E + DE*COSE - DS*SINE
    SC = S + DE*SINE + DS*COSE
    ;TRANSFORM DETECTOR'S POINTING ANGLES TO GEOGRAPHIC COORDINATES            
    ;OF THE CORRESPONDING POINT ON THE EARTH SURFACE.                          
    ;NOTE:  IF A DETECTOR LOOKS OFF THE EARTH, THE RELATED LATITUDE            
    ;AND LONGITUDE ARE SET TO 999999.                                   
    LPOINT,EV,SC,GEO(I-1,1-1),GEO(I-1,2-1),IER
    H=-H
endfor                          ;  10 CONTINUE
end

;***
