;****I* idl/idl.stdev
; NAME
; stdev
; 
; PURPOSE
; To calculate the standard deviation of a set of numbers
; 
; USAGE
; INPUT
; OUTPUT
; RESULT
; EXAMPLE
; USES
; * Nothing outside of IDL's internal routine.
; 
; USED BY
; Just about everything.
; * b1read_uws_g56.pro
; * b1u_coastline_navigation.pro
; * b1u_get_center.pro
; 
; NOTES
; TODO
; BUGS
; AUTHOR
; Ken Knapp, NOAA/NCDC/RSAD
; 
; CREATION DATE
; Unknown.
; 
; HISTORY
; SOURCE

function stdev, ARRAY,mean=mean
;
;	function calculates the standard deviation
;	of the array ARRAY
;
if n_elements(array) eq 0 then return,-1
n = n_elements(array)
;
mean = total(array) / n
;
stdev=sqrt(((total((array-mean)^2)))/n)
return,stdev
end
;***
