;****I* idl/idl.systime_iso
; NAME
; systime_iso
; 
; PURPOSE
; To return the current sytem time in ISO format.
; 
; USAGE
; INPUT
; nothing
; 
; OUTPUT
; Returns the scalar string of current ISO time.
; 
; RESULT
; EXAMPLE
; 
; USES
; Only internal IDL routines
; 
; USED BY
; * idl.b1u_2_grisat
; 
; NOTES
; TODO
; BUGS
; AUTHOR
; Ken Knapp, NOAA/NCDC/RSAD
; 
; CREATION DATE
; 
; HISTORY
; 
; SOURCE

function systime_iso
now = systime()
b = bin_date(now)
string=string(b(0),format='(i4.4)')+'-'+ $
       string(b(1),format='(i2.2)')+'-'+ $
       string(b(2),format='(i2.2)')+' '+ $
       string(b(3),format='(i2.2)')+':'+ $
       string(b(4),format='(i2.2)')+':'+ $
       string(b(5),format='(i2.2)')
return,string
end
;***
